working=/users/rg/buszczynska/Projects/drz/quiros

cd $working

# -------------------------------------------------
# Get the matrices with raw gene counts
# -------------------------------------------------

# Supplementary table S3 and S4

cat ms.matrix.tmp.tsv| awk 'BEGIN{FS=OFS="\t"}{print $1"_"$2,$3,$4,$5,$6}'| grep -v Protein| cut -f1,2 > ms.r1.tmp.tsv
cat ms.matrix.tmp.tsv| awk 'BEGIN{FS=OFS="\t"}{print $1"_"$2,$3,$4,$5,$6}'| grep -v Protein| cut -f1,3 > ms.r2.tmp.tsv
cat ms.matrix.tmp.tsv| awk 'BEGIN{FS=OFS="\t"}{print $1"_"$2,$3,$4,$5,$6}'| grep -v Protein| cut -f1,4 > ms.r3.tmp.tsv
cat ms.matrix.tmp.tsv| awk 'BEGIN{FS=OFS="\t"}{print $1"_"$2,$3,$4,$5,$6}'| grep -v Protein| cut -f1,5 > ms.r4.tmp.tsv

for typ in r1 r2 r3 r4
do
    /users/rg/buszczynska/python_scripts/average.py -i ms.$typ.tmp.tsv -o ms.$typ.tsv
done

join.py -a ms.r2.tsv -b ms.r1.tsv -x 1 -y 1 > ms.r1.r2.tsv
join.py -a ms.r3.tsv -b ms.r1.r2.tsv -x 1 -y 1 > ms.r1.r2.r3.tsv
{ echo -e "CON1\tCON2\tMB1\tMB2"; join.py -a ms.r4.tsv -b ms.r1.r2.r3.tsv -x 1 -y 1 ; } > ms.matrix.tsv

# --------------------------------------------------------------------
# edgeR
# --------------------------------------------------------------------

for typ in rnaseq ms
do
    ~abreschi/R/scripts/edgeR.analysis.R -i $typ.matrix.tsv -m $typ.targets.tsv -o $typ.DEA -f treatment
done

#/users/rg/buszczynska/python_scripts/average.records.py -i ms.matrix.tsv -o TEST


# --------------------------------------------------------------------
# Deseq
# --------------------------------------------------------------------

for typ in rnaseq ms 
do
    ~abreschi/R/scripts/DESeq.analysis.R -i $typ.matrix.tsv -m $typ.targets.tsv -o deseq.$typ.DEA.tsv -f treatment
done
 
