#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
        help="GTF/GTF. No stdin")
parser.add_option('-o', help='Output GTF file with new tag')
parser.add_option('-v', help='tag value')



options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
val=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:v:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -t tag -v val " % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-v':
        val=a 
       
print ("Input file : %s \nOutput file: %s \nValue %s" % (infile,outfile,val))


def addTag():

    gtf={}

    gtf_file=open(infile, 'r')
    for line in gtf_file:
        line_split=line.split("\n")[0].split("\t")
        typ=line_split[2]

        if typ == "exon":

            chrN=line_split[0]
            sth=line_split[1]
            typ=line_split[2]
            start=line_split[3]  
            stop=line_split[4]
            dot1=line_split[5]
            strand=line_split[6]
            dot2=line_split[7]
            geneID=line_split[8].split(';')[0].split('gene_id')[1].split('"')[1]
            #print "geneID", geneID
                   
            txID=line_split[8].split(';')[1].split('transcript_id')[1].split('"')[1]
            new_txID=txID+"_"+val
            #print "TX_ID", new_txID


            lineR=(chrN+"\t"+sth+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+' "'+geneID+'"'+";"+" "+"transcript_id"+' "'+new_txID+'"'+";")


            if txID not in gtf:
                gtf[txID]=[lineR]
            else:
                gtf[txID].append(lineR)


    f=open(outfile, "w")
    for k in gtf:
        for v in gtf[k]:
            f.write('%s\n' % v)
    f.close() 

 
addTag()
