#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt
import numpy

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
        help="The input is output of bwtools.monoexonic.ROIs.py script. No stdin")
parser.add_option('-o', help='Output file with average values per each position')
parser.add_option('-a', help='Name of the field to add field', default="")

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
add=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:a:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-a':
        add=a
print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of parsing_bwtool

def avegare_bwtool():

    averaged={}
    final={}

    bwtool_out=open(infile, 'r')
    for line in bwtool_out:
        line_split=line.split('\n')[0].split('\t') 
        #print "line_split", line_split 
        pos=int(line_split[1])
        value=float(line_split[2])
        #print "POS", pos   
        #print "VALUE", value

        if pos not in averaged:
            averaged[pos]=[value]
        else:
            averaged[pos].append(value)

        #print "AVERAGED", pos, averaged[pos]    

    for key in averaged:
        final[key]=round(numpy.mean(averaged[key]),2)
        #print "averaged[key]", key, averaged[key]
        #print "final[key]", key, final[key] 

    if add != "":
        f=open(outfile, 'w')
        for key in final:
            f.write('%s\t' % key)
            f.write('%s\t' % final[key])
            f.write('%s\n' % add) 
        f.close()
    
    if add == "":
        f=open(outfile, 'w')
        for key in final:
            f.write('%s\t' % key)
            f.write('%s\n' % final[key]) 
        f.close()
     
      
avegare_bwtool()

