#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is tab separated file with ID and value. No stdin")
parser.add_option('-o', help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
take=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def merge():

    gene_read={}
    merged={} 

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print 'LS', line_split
        gene_id=line_split[0]
        reads=line_split[1].split('\n')[0]
        #print 'LN', length

        if gene_id not in gene_read:
            gene_read[gene_id]=[float(reads)]
        else:
            gene_read[gene_id].append(float(reads)) 

         
    for key in gene_read:
        merged_reads=sum(gene_read[key])/len(gene_read[key])
 
        merged[key]=(key, str(merged_reads))

    f=open(outfile, 'w')
    for keys in merged:
        for value in merged[keys]:
            f.write('%s\t' % value)
        f.write('\n')  
    f.close()
 
merge()
