#!/usr/bin/python

__author__="BU"


"""This script slices bed records into fragments of defined length"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re
import numpy
from collections import OrderedDict


# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bed format without str info")
parser.add_option('-o', help='Fragmented bed')
parser.add_option('-l', help='Length of fragments')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
length=''
strand=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        lengthF=a

print ("Input file : %s \nOutput file: %s  \nLength: %s" % (infile,outfile,lengthF))

# subtract

#def restartable(seq):
#    while True:
#        for item in seq:
#            restart = yield item
#            if restart:
#                break
#        else:
#            raise StopIteration

def slicer():

    "This function slices records in bed file using defined fragment length"
    pieces=[]
    lens=[]

    match=open(lengthF, 'r')
    for lR in match:
        lens.append(lR.split('\n')[0])

    bed=open(infile, 'r')
    count=0
    for line in bed:
        countR=0
        #print "countR", countR 
        record=line.split('\n')[0].split('\t')
        #print record
        chrN=record[0]
        start=record[1]
        stop=record[2]
        name=record[3].split('=AL:')[0]

        while count <= len(lens):
            #print "COUNT", count
            length=lens[count]
            count +=1
            #print "length", length
            #print record
            if countR > 0:
                #print "I am countR > 0" 
                fraglen=int(stop)-countR
                if fraglen > int(length):
                    i=countR 
                    j=i+int(length)
                    #print "countR", countR
                    #print "LEN", length 
                    #print "J", j
                    countR=int(i)+int(length)
                    if int(stop) - i > int(length):
                        #print "STOP is bigger"
                        coord=name+"=AL:"+str(i)+"="+str(j)
                        newRecord=chrN+"\t"+str(i)+"\t"+str(j)+"\t"+coord
                        pieces.append(newRecord)
                        #print "NR", newRecord
                    if int(stop) - i < int(length):
                        coord=name+"=AL:"+str(i)+"="+str(stop)
                        newRecord=chrN+"\t"+str(i)+"\t"+str(stop)+"\t"+coord
                        pieces.append(newRecord)
                    if count == len(lens):        
                        count = len(lens)/2
  
                if fraglen <= int(length):
                    #if int(countR) != int(stop):
                    #print record
                    i=countR 
                    coord=name+"=AL:"+str(countR)+"="+str(stop)
                    newRecord=chrN+"\t"+str(countR)+"\t"+str(stop)+"\t"+coord
                    pieces.append(newRecord)
                    countR=int(i)+int(length)
                    if count == len(lens):        
                        count = len(lens)/2
                    break 

            if countR == 0:
                #print "I am countR 0"
                fraglen=int(stop)-int(start)
                if fraglen > int(length):
                    i=int(start) 
                    j=i+int(length)
                    countR=int(i)+int(length)
                    #print "countR", countR
                    if int(stop) - i > int(length):
                        coord=name+"=AL:"+str(i)+"="+str(j)
                        newRecord=chrN+"\t"+str(i)+"\t"+str(j)+"\t"+coord
                        pieces.append(newRecord)
                    if int(stop) - i < int(length):
                        coord=name+"=AL:"+str(i)+"="+str(stop)
                        newRecord=chrN+"\t"+str(i)+"\t"+str(stop)+"\t"+coord
                        pieces.append(newRecord)  
                    if count == len(lens):        
                        count = len(lens)/2
                if fraglen <= int(length):
                    #if int(start) != int(stop):
                    #print record
                    coord=name+"=AL:"+str(start)+"="+str(stop)
                    newRecord=chrN+"\t"+str(start)+"\t"+str(stop)+"\t"+coord
                    pieces.append(newRecord)
                    countR=int(start)+int(length)
                    if count == len(lens):        
                        count = len(lens)/2
                    break  

    
    f=open(outfile, 'w')
    for item in pieces:
        f.write('%s\n' % item)
    f.close()     
  
slicer()


