#!/usr/bin/python

__author__="BU"


"""This script slices bed records into fragments of defined length"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re
import numpy
from collections import OrderedDict


# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bed format without str info")
parser.add_option('-o', help='Fragmented bed')
parser.add_option('-l', help='Length of fragments')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
length=''
strand=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        length=a

print ("Input file : %s \nOutput file: %s  \nLength: %s" % (infile,outfile,length))

# subtract

def slicer():

    "This function slices records in bed file using defined fragment length"
    pieces=[]

    bed=open(infile, 'r')
    for line in bed:
        record=line.split('\n')[0].split('\t')
        #print record
        chrN=record[0]
        start=record[1]
        stop=record[2]
        name=record[3]
        fraglen=int(stop)-int(start)
        if fraglen >= int(length):
            #seg=numpy.arange(0, int(fraglen), int(length))
            seg=numpy.arange(int(start), int(stop), int(length))
            #print 'seg', seg
            for i in seg:
                j=i+int(length)
                #print "I", i
                #print "J", j
                qc=int(stop) - j
                #print "QC", qc
                if qc > 0:
                    coord=name+"__PX-"+str(i)+"-"+str(j)
                    newRecord=chrN+"\t"+str(i)+"\t"+str(j)+"\t"+coord
                    pieces.append(newRecord) 
                  
    f=open(outfile, 'w')
    for item in pieces:
        f.write('%s\n' % item)
    f.close()     
  
slicer()

