#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt
#import subprocess
from operator import itemgetter
import re

# ===============
## OPTION PARSING
# ===============
#parser = OptionParser()
#parser.add_option("-i", 
#	help="The input format is metafile in .txt format with fields sep by '\ t' file containing full names of all files that are going to be used for creating a metafile. No stdin")
#parser.add_option("-c", help="column number with identifier. All identifiers must be unique")
#parser.add_option('-e',help="column number with element for which metafile is going to be created")
#parser.add_option('-o', help='output file')
#parser.add_option('-r',help='file containing reference identifiers. This is is required, when all input files (provided as a list in -i) have different number of rows')

#options, args = parser.parse_args()


# Store input and output file

inECR=''
inEWR=''
outfile=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:j:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input1 -j input2 -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        inECR=a
    if o == '-j':
        inEWR=a  
    if o == '-o':
        outfile=a

print ("Input file1 : %s \nInput file2 : %s \nOutput file: %s " % (inECR,inEWR,outfile))

# ===========================================================
# Running the bash script that produces bins of ECR and EWR
# ===========================================================

#def run_shell_script():  
#    subprocess.call(['~buszczynska/line_repeats/repeat-containing-exons/exon.expression.analysis.03062014/binning.ECR.EWR.based.on.expression.sh'])
#    print 'YES!'
 
#run_shell_script()

def getting_exons(ECR_file, EWR_file):

    ECR_mean={}
    EWR_mean={}
    EWR_selected={}
    ECR_EWR_pairs={}

    ECR=open(ECR_file, 'r') 
    for line in ECR: 
        line_split=line.split('\t')
        ECR_id=line_split[0]
        ECR_mean_exp=line_split[19].split('\n')[0]
        ECR_mean[ECR_id]=ECR_mean_exp
    #print 'ECR list', len(ECR_mean.keys())
        
    EWR=open(EWR_file, 'r')
    for lines in EWR:
        lines_split=lines.split('\t')
        EWR_id=lines_split[0]
        EWR_mean_exp=lines_split[19].split('\n')[0]
        EWR_mean[EWR_id]=EWR_mean_exp
        

    for key in EWR_mean:
        if len(EWR_selected.keys()) <= len(ECR_mean.keys()):
          EWR_selected[key]=EWR_mean[key]
          
    ECR_sorted=sorted([(value,ky) for (ky,value) in ECR_mean.items()])
    EWR_selected_sorted=sorted([(v,k) for (k,v) in EWR_selected.items()])

    for (item, items) in zip(ECR_sorted, EWR_selected_sorted):
        for (elem, elems) in zip(item, items):
            if elem.startswith('ENSE'):
                ecr_id=elem
            if elems.startswith('ENSE'):
                ewr_id=elems

                ECR_EWR_pairs[ecr_id]=ewr_id
    return ECR_EWR_pairs
                
# ============================================
# Running the binning on all ECR and EWR files
# ============================================

meta_data={}

list_of_ECR=open(inECR, 'r')
list_of_EWR=open(inEWR, 'r')

for ECR_bin, EWR_bin in zip(list_of_ECR, list_of_EWR):
    ECRs=ECR_bin.split('\n')[0]
    #print ECR_bin
    EWRs=EWR_bin.split('\n')[0]
    #print EWRs
    file_dict=getting_exons(ECRs, EWRs)
    
    for keys in file_dict:
        meta_data[keys]=file_dict[keys]


f = open(outfile, 'w')
for q in meta_data:
    f.write('%s\t' % q)
    f.write('%s\n' % meta_data[q])
f.close()








        
