#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt
import numpy

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
        help="The input format is bwtool extract output with -fill=0. No stdin")
parser.add_option('-o', help='Output file')


options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of parsing_bwtool

def parsing_bwtool():

    nb=[]
    tmpP=[]
    tmpV=[] 
    parsed={}

    bwtool_out=open(infile, 'r')
    for line in bwtool_out:
        line_split=line.split('\t') 
        chrom=line_split[0]
        start=line_split[1]
        stop=line_split[2]
        trans_id=line_split[3]
        strand=line_split[5]
        length=float(line_split[6])
        values=line_split[7].split('\n')[0]
        values_split=values.split(',')
        denom= 100/length

        scale_tmp=int(round(length/100))
        if float(scale_tmp) > length/100:
            scale=int(scale_tmp)-1
            print "SCALE", scale
            print "SCALE_tmp", scale_tmp
        if float(scale_tmp) <= length/100:
            scale=int(scale_tmp)
            
        ref=range(1, 101)
        rev=list(reversed(range(1, 101)))
        #print "REV", rev

        # -------------------------------------------------
        # STRAND == "+"
        # -------------------------------------------------

        # Equal 100

        if length == 100 and strand == "+":
            for elem in values_split:
                nb.append(elem)  
                if elem != '':
                    pos=denom*len(nb)
                    value=str(int(pos))+"\t"+elem        
                    
                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)
            #print "PARSED", trans_id, parsed[trans_id]
            nb=[]

        # Less than 100  

        if length < 100 and strand == "+":
            for elem in values_split:
                nb.append(elem)
                if elem != '':
                    if elem != '0.00':                   
                        pos=denom*len(nb)
                    else:
                        pos=denom*len(nb)
            
                tmpP.append(round(pos))
                tmpV.append(elem)
            nb=[]

            for item in ref:
                if item in tmpP:
                    take=tmpP.index(item)
                    value=str(item)+"\t"+tmpV[take]
                if item not in tmpP:               
                    take=min(range(len(tmpP)), key=lambda i: abs(tmpP[i]-item))
                    value=str(item)+"\t"+tmpV[take]
                
                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)

            #print "PARSED", trans_id, parsed[trans_id]
            tmpP=[]
            tmpV=[]

        # More than 100  

        if length > 100 and strand == "+":
            oper=values_split
            
            for i in range(len(oper)):
                oper[i] = float(oper[i])

            #print "SCALE", scale
            for item in ref:
                take=numpy.mean(oper[:scale])
                value=str(item)+"\t"+str(take)

                #print "ITEM", item            
                #print "TAKE", take
                #print "OPER", oper[:scale]
                #print "OPER", oper
                #print "LEN OPER", len(oper)

                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)
  
                del oper[:scale]
  
            print "PARSED", trans_id, parsed[trans_id]


        # -------------------------------------------------
        # STRAND == "-"
        # -------------------------------------------------

        # Equal 100

        if length == 100 and strand == "-":
            for elem in values_split:
                nb.append(elem)  
                if elem != '':
                    pos=denom*len(nb)
                    value=str(int(101-pos))+"\t"+elem        
                    
                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)
            #print "PARSED", trans_id, parsed[trans_id]
            nb=[]

       # Less than 100  

        if length < 100 and strand == "-":
            for elem in values_split:
                nb.append(elem)
                if elem != '':
                    if elem != '0.00':                   
                        pos=denom*len(nb)
                    else:
                        pos=denom*len(nb)
            
                tmpP.append(round(101-pos))
                tmpV.append(elem)
            nb=[]

            for item in rev:
                if item in tmpP:
                    take=tmpP.index(item)
                    value=str(item)+"\t"+tmpV[take]
                if item not in tmpP:               
                    take=min(range(len(tmpP)), key=lambda i: abs(tmpP[i]-item))
                    value=str(item)+"\t"+tmpV[take]
                
                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)

            #print "PARSED", trans_id, parsed[trans_id]
            tmpP=[]
            tmpV=[]

        # More than 100  

        if length > 100 and strand == "-":
            oper=values_split
            
            for i in range(len(oper)):
                oper[i] = float(oper[i])

            for item in rev:
                take=numpy.mean(oper[:scale])
                value=str(item)+"\t"+str(take)
            
                if trans_id not in parsed:
                    parsed[trans_id]=[value]
                else:
                    parsed[trans_id].append(value)
  
                del oper[:scale]
  
            #print "PARSED", trans_id, parsed[trans_id]


    f=open(outfile, 'w')
    for key in parsed:
        for val in parsed[key]:
            f.write('%s\t' % key)
            f.write('%s\n' % val)
    f.close()

parsing_bwtool()

