#!/usr/bin/python

__author__="BUR"


"""This script will help to clean input records for kmer matrix (Project X). It filters the bed file to remove all non-strand specific non-exonic records."""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re


# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is a bed file with ids of merged regions in the 4th field.)")
parser.add_option('-o', help='Bed file with strand specific records')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def filter():
    
    records={}
    strander={}
    filtered={}   

    bed=open(infile, 'r')
    for line in bed:
        line_split=line.split('\n')[0].split('\t')
        name=line_split[3]

        if name not in records:
            records[name]=[line]
        else:
            records[name].append(line)

        for elem in name.split(','):
            #print name,'\t',elem.split('=')[3]
            strand=elem.split('=')[3]
                

            if name not in strander:
                strander[name]=[strand]
            else:
                strander[name].append(strand)

    f=open(outfile, "w")
    for key in strander:
        uniq=set(strander[key])
        if len(uniq) == 1:
            for e in records[key]:
                f.write('%s\n' % e.split('\n')[0])
    f.close()            
            #filtered[key]=records[key]
            #print "FINAL", records[key][0]
        #print "regular", strander[key], len(strander[key])
        #print "uniq", set(strander[key]), len(set(strander[key]))
 
filter()


