#!/usr/bin/python

__author__="BU"


"""This script creates metafile containing in each row exon_coord and RPKM or EIR values. If value is not present for given exon in given sample, NA values are introduced."""

# Usage python metafile.expression.ir.ECR.EWR.py -i input.gtf -o sjfile.txt -m ECR (or EWR)

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''
list_elem=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        list_elem=a

print ("Input file : %s \nOutput file: %s \nList: %s" % (infile,outfile,list_elem) )

def convert_cpat():

    cpat_id={}
    havana_ensembl={}
    converted={}

    cpat=open(infile, 'r')
    for line in cpat:
        line_split=line.split('\t')
        ensembl_id=line_split[0]

        cpat_id[ensembl_id]=line   

    list_ids=open(list_elem, 'r')
    for record in list_ids:
        record_split=record.split('\t')
        havana=record_split[0]
        ensembl=record_split[1].split('\n')[0]

        havana_ensembl[ensembl]=havana         
         
    for key in cpat_id:
        if key in havana_ensembl:
            converted[havana_ensembl[key]]=cpat_id[key]
       
    f=open(outfile, 'w')
    for k in converted:
        f.write('%s\t' % k)
        f.write('%s' % converted[k])   
    f.close()

convert_cpat()
 
