#!/usr/bin/python

__author__="BU"


"""This script creates metafile containing in each row exon_coord and RPKM or EIR values. If value is not present for given exon in given sample, NA values are introduced."""

# Usage python metafile.expression.ir.ECR.EWR.py -i input.gtf -o sjfile.txt -m ECR (or EWR)

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''
list_elem=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        list_elem=a

print ("Input file : %s \nOutput file: %s \nList: %s" % (infile,outfile,list_elem) )

def convert():

    havana_ensembl={}

    gtf=open(infile, 'r')
    for line in gtf:
        line_split=line.split('\t')
        cigar=line_split[8]
        cigar_split=cigar.split(';')
        for record in cigar_split:
           
            if record.startswith(' transcript_id'):
                ensembl_id=record.split('"')[1]
            if record.startswith(' havana_transcript'):
                havana_id=record.split('"')[1].split('.')[0]
                havana_ensembl[havana_id]=ensembl_id
                #print 'HE', havana_id, havana_ensembl[havana_id]

    f=open(outfile, 'w')
    for key in havana_ensembl:
        f.write('%s\t' % key)
        f.write('%s\n' % havana_ensembl[key])
    f.close() 

convert()
