#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# -------------------------------------------------------------
## OPTION PARSING
# -------------------------------------------------------------
parser = OptionParser()
parser.add_option("-i", 
	help="The input is p3primer.set.gtf file. No stdin")
parser.add_option('-m', help='Mode: old, old2, new, ancient (only batchI and batchII), simple. RT-PCR-Seq primers were delivered in two diffent outputs and they require two different ways of conversion.')
parser.add_option('-o', help='Output file')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
mode=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:m:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-m':
        mode=a

print ("Input file : %s \nOutput file: %s \nMode: %s" % (infile,outfile,mode))

# -------------------------------------------------------------
# Function convert
# -------------------------------------------------------------

def convert():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        start=line_split[3]
        stop=line_split[4]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        for elem in cigar:
            if elem.startswith('gene_id'):
               gene=elem
            if elem.startswith(' transcript_id'):
               trans=elem
            if elem.startswith(' gene_type'):
                gene_type=elem
            if elem.startswith(' gene_status'):
                gene_status=elem
            if elem.startswith(' gene_name'):
                gene_name=elem
            if elem.startswith(' transcript_type'):
                transcript_type=elem
            if elem.startswith(' transcript_status'):
                transcript_status=elem
            if elem.startswith(' transcript_name'):
                transcript_name=elem
            if elem.startswith(' level'):
                level=elem
                print level 
            if elem.startswith(' havana_gene'):
                havana_gene=elem
            if elem.startswith(' havana_transcript'):
                havana_trans=elem
            if elem.startswith(' sj_id'):
                sj=elem
            if elem.startswith(' EJ_ex1'):
                ej_ex1=elem
            if elem.startswith(' EJ_ex2'):
                ej_ex2=elem 
            if elem.startswith(' Primer_F_id'):
                primerF=elem
            if elem.startswith(' Primer_R_id'):
                primerR=elem
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
            if elem.startswith(' Primer_F_gc'):
                primerF_gc=elem
            if elem.startswith(' Primer_R_gc'):
                primerR_gc=elem
            if elem.startswith(' Primer_F_tm'):                
                primerF_tm=elem
            if elem.startswith(' Primer_R_tm'):
                primerR_tm=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' target_start'):
                target_start=elem
            if elem.startswith(' target_end'):
                target_end=elem
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+strand+'\t'+gene+';'+trans+';'+gene_type+';'+gene_status+';'+gene_name+';'+transcript_type+';'+transcript_status+';'+transcript_name+';'+level+';'+havana_gene+';'+havana_trans+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+primerF_pos+';'+primerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

# -------------------------------------------------------------
# Function convert for old output
# -------------------------------------------------------------

def convert_old():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        for elem in cigar:
            if elem.startswith('gene_id'):
               gene=elem
            if elem.startswith(' transcript_id'):
               trans=elem
            if elem.startswith(' gene_type'):
                gene_type=elem
            if elem.startswith(' gene_status'):
                gene_status=elem
            if elem.startswith(' gene_name'):
                gene_name=elem
            if elem.startswith(' transcript_type'):
                transcript_type=elem
            if elem.startswith(' transcript_status'):
                transcript_status=elem
            if elem.startswith(' transcript_name'):
                transcript_name=elem
            if elem.startswith(' level'):
                level=elem
            if elem.startswith(' havana_gene'):
                havana_gene=elem
            if elem.startswith(' havana_transcript'):
                havana_trans=elem
            if elem.startswith(' EJ_id'):
                sj=" sj_id"+" "+elem.split(' ')[2]
                #print sj
            if elem.startswith(' EJ_ex1'):
                ej_ex1=elem
                start=elem.split(' ')[2].split(',')[0].split('"')[1]
            if elem.startswith(' EJ_ex2'):
                ej_ex2=elem
                stop=elem.split(' ')[2].split(',')[1].split('"')[1] 
            if elem.startswith(' Primer_F_id'):
                primerF=elem
            if elem.startswith(' Primer_R_id'):
                primerR=elem
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
            if elem.startswith(' Primer_F_gc'):
                primerF_gc=elem
            if elem.startswith(' Primer_R_gc'):
                primerR_gc=elem
            if elem.startswith(' Primer_F_tm'):                
                primerF_tm=elem
            if elem.startswith(' Primer_R_tm'):
                primerR_tm=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' target_start'):
                target_start=elem
            if elem.startswith(' target_end'):
                target_end=elem
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+strand+'\t'+gene+';'+trans+';'+gene_type+';'+gene_status+';'+gene_name+';'+transcript_type+';'+transcript_status+';'+transcript_name+';'+level+';'+havana_gene+';'+havana_trans+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+primerF_pos+';'+primerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

# -------------------------------------------------------------
# Function convert for batch I
# -------------------------------------------------------------

def convert_ancient():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        start=line_split[3]
        stop=line_split[4]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        gene="gene_id"+" "+'"'+"NA"+'"'
        trans=" transcript_id"+" "+'"'+"NA"+'"'
        gene_type=" gene_type"+" "+'"'+"NA"+'"'
        gene_status=" gene_status"+" "+'"'+"NA"+'"'
        gene_name=" gene_name"+" "+'"'+"NA"+'"'
        transcript_name=" transcript_name"+" "+'"'+"NA"+'"'
        level=" level"+" "+'"'+"NA"+'"'
        primerF=" Primer_F_id"+" "+'"'+"NA"+'"'
        primerR=" Primer_R_id"+" "+'"'+"NA"+'"'
        primerF_gc=" Primer_F_gc"+" "+'"'+"NA"+'"' 
        primerR_gc=" Primer_R_gc"+" "+'"'+"NA"+'"'
        primerF_tm=" Primer_F_tm"+" "+'"'+"NA"+'"'
        primerR_tm=" primerR_tm"+" "+'"'+"NA"+'"'
        target_start=" target_start"+" "+'"'+"NA"+'"'
        target_end="  target_end"+" "+'"'+"NA"+'"'     
        for elem in cigar:
            if elem.startswith('transcript_type'):
                transcript_type=" "+elem
            if elem.startswith(' transcript_status'):
                transcript_status=elem
            if elem.startswith(' "havana_gene'):
                havana_gene=elem
            if elem.startswith(' havana_transcript'):
                havana_trans=elem
            if elem.startswith(' EJ_id'):
                sj=" sj_id"+" "+elem.split(' ')[2]
                ex1_stop=elem.split(' ')[2].split('_')[1]
                ex2_start=elem.split(' ')[2].split('_')[2].split('"')[0] 
                #print sj
                ej_ex1=" EJ_ex1"+" "+'"'+start+'"'+","+'"'+ex1_stop+'"'
                ej_ex2=" EJ_ex2"+" "+'"'+ex2_start+'"'+","+'"'+stop+'"'
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+strand+'\t'+gene+';'+trans+';'+gene_type+';'+gene_status+';'+gene_name+';'+transcript_type+';'+transcript_status+';'+transcript_name+';'+level+';'+havana_gene+';'+havana_trans+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+primerF_pos+';'+primerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

# -------------------------------------------------------------
# Function convert for old output
# -------------------------------------------------------------

def convert_old2():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        for elem in cigar:
            if elem.startswith('gene_id'):
               gene=elem
            if elem.startswith(' transcript_id'):
               trans=elem
            if elem.startswith(' gene_type'):
                gene_type=elem
            if elem.startswith(' gene_status'):
                gene_status=elem
            if elem.startswith(' gene_name'):
                gene_name=elem
            if elem.startswith(' transcript_type'):
                transcript_type=elem
            if elem.startswith(' transcript_status'):
                transcript_status=elem
            if elem.startswith(' transcript_name'):
                transcript_name=elem
            if elem.startswith('  level'):
                level=elem
            if elem.startswith(' havana_gene'):
                havana_gene=elem
            if elem.startswith(' havana_transcript'):
                havana_trans=elem
            if elem.startswith(' EJ_id'):
                sj=" sj_id"+" "+elem.split(' ')[2]
                #print sj
            if elem.startswith(' EJ_ex1'):
                ej_ex1=elem
                start=elem.split(' ')[2].split(',')[0].split('"')[1]
            if elem.startswith(' EJ_ex2'):
                ej_ex2=elem
                stop=elem.split(' ')[2].split(',')[1].split('"')[1] 
            if elem.startswith(' Primer_F_id'):
                primerF=elem
            if elem.startswith(' Primer_R_id'):
                primerR=elem
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
            if elem.startswith(' Primer_F_gc'):
                primerF_gc=elem
            if elem.startswith(' Primer_R_gc'):
                primerR_gc=elem
            if elem.startswith(' Primer_F_tm'):                
                primerF_tm=elem
            if elem.startswith(' Primer_R_tm'):
                primerR_tm=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' target_start'):
                target_start=elem
            if elem.startswith(' target_end'):
                target_end=elem
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+strand+'\t'+gene+';'+trans+';'+gene_type+';'+gene_status+';'+gene_name+';'+transcript_type+';'+transcript_status+';'+transcript_name+';'+level+';'+havana_gene+';'+havana_trans+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+primerF_pos+';'+primerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

# -------------------------------------------------------------
# Function convert for simple output
# -------------------------------------------------------------

def convert_simple():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        for elem in cigar:
            if elem.startswith('gene_id'):
               gene=elem
            if elem.startswith(' transcript_id'):
               trans=elem
            if elem.startswith(' EJ_id'):
                sj=" sj_id"+" "+elem.split(' ')[2]
                #print sj
            if elem.startswith(' EJ_ex1'):
                ej_ex1=elem
                start=elem.split(' ')[2].split(',')[0].split('"')[1]
            if elem.startswith(' EJ_ex2'):
                ej_ex2=elem
                stop=elem.split(' ')[2].split(',')[1].split('"')[1] 
            if elem.startswith(' Primer_F_id'):
                primerF=elem
            if elem.startswith(' Primer_R_id'):
                primerR=elem
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
            if elem.startswith(' Primer_F_gc'):
                primerF_gc=elem
            if elem.startswith(' Primer_R_gc'):
                primerR_gc=elem
            if elem.startswith(' Primer_F_tm'):                
                primerF_tm=elem
            if elem.startswith(' Primer_R_tm'):
                primerR_tm=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' target_start'):
                target_start=elem
            if elem.startswith(' target_end'):
                target_end=elem
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+strand+'\t'+gene+';'+trans+';'+' gene_type "NA"'+';'+' gene_status "NA"'+';'+' gene_name "NA"'+';'+' transcript_type "NA"'+';'+' transcript_status "NA"'+';'+' transcript_name "NA"'+';'+' level "NA"'+';'+' havana_gene "NA"'+';'+' havana_trans "NA"'+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+primerF_pos+';'+primerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

# -------------------------------------------------------------
# Execution!!!!!
# -------------------------------------------------------------
  
if mode == 'new':
    convert()
if mode == 'old':  
    convert_old()
if mode == 'old2':  
    convert_old2()
if mode == 'ancient':
    convert_ancient()  
if mode == 'simple':
    convert_simple()  
if mode != 'new' and mode != 'old' and mode != 'ancient' and mode != 'simple' :
    print 'SPECIFY MODE!'   
