#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is tab separated file with gene_id, exon_coord and exon position. No stdin")
parser.add_option('-o', help='Output file with matched exons by position')
parser.add_option('-r',help='File containing reference exons. Tab-delimited with gene_id, exon_coord and exon position. No stdin')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r ref" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a

print ("Input file : %s \nOutput file: %s \nReference: %s" % (infile,outfile,ref))

def select():

    exon_loc={}
    exon_gene={}
    reference={}
    selecta={}
    control=[]
    #ctrl_gene=[] # this allows you to control by gene, meaning exclude those genes for which matching exons were selected

    input_file=open(infile, "r")
    for line in input_file:
        line_split=line.split('\n')[0].split('\t')
        gene=line_split[0]
        exon=line_split[1]
        pos=line_split[2]        
        #print 'EXON', exon
        #print 'pos', pos
             
        if exon not in exon_loc:
            exon_loc[exon]=[pos]
        else:
            exon_loc[exon].append(pos)
        #print 'EXON_LOC', exon, exon_loc[exon]

        exon_gene[exon]=gene
        #print exon, exon_gene[exon]

    reference_file=open(ref, 'r')
    for record in reference_file:
        record_split=record.split('\n')[0].split('\t')
        exon_ref=record_split[1]
        pos_ref=record_split[2]
        
        if exon_ref not in reference:
            reference[exon_ref]=[pos_ref]
        else:
            reference[exon_ref].append(pos_ref) 
        #print 'REFRENCE', exon_ref, reference[exon_ref]
     
    for key in reference:
        #print key
        if len(selecta.keys()) < len(exon_loc.keys()):
            #print 'LENGTH SELECTA:', len(selecta.keys())
            for kyz in exon_loc:
                if key not in control:
                    #if exon_gene[kyz] not in ctrl_gene:
                    if len(exon_loc[kyz]) == len(reference[key]):
                        for value in reference[key]:
                            if value in exon_loc[kyz]:
                                if kyz not in selecta:
                                    selecta[kyz]=key
                                    control.append(key)
                                    #ctrl_gene.append(exon_gene[kyz])   
                                    #print 'CONTROL', control

    f=open(outfile, 'w')
    for k in selecta:
        f.write('%s\t' % k)
        f.write('%s\n' % selecta[k])
    f.close()

select()
       
