#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
        help="The input format is bedtools intersect output with -wa and -wb. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-r', help='gtf file with stop codons')
parser.add_option('-m', help='Output file with minimal distance to stop codon')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
stop=''
mini=''
 
# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:m:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r stop -m mini" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        stop=a 
    if o == '-m':
        mini=a 
 
print ("Input file : %s \nOutput file: %s\nCodon file: %s\nMinimal distance output file: %s" % (infile,outfile,stop,mini))

def get_distance():

    gold_tx={}
    gold_coord={}
    stop_coord={}
    gold_dist={}
    gold_min={}
    l=[]

    gtf_file=open(infile, 'r')
    for line in gtf_file:
        line_split=line.split('\n')[0].split('\t')
        #print line_split
        goldStart=line_split[3]
        goldStop=line_split[4] 
        goldStrand=line_split[6]
        #print "START", goldStart 
        #print "STOP", goldStop
        #print "STR", goldStrand
        goldCoord=goldStart+"_"+goldStop+"_"+goldStrand        

        goldID=line_split[8].split(';')[1].split(' ')[2].split('"')[1]
        txID=line_split[17].split(';')[1].split(' ')[2].split('"')[1]
        
        if goldID not in gold_tx:
            gold_tx[goldID]=[txID]
        else:
            gold_tx[goldID].append(txID)

        #print goldID, gold_tx[goldID]

        gold_coord[goldID]=goldCoord
        #print goldID, len(gold_coord)

 
    stop_file=open(stop, 'r')
    for record in stop_file:
        record_split=record.split('\n')[0].split('\t')  
        stopID=record_split[8].split(';')[1].split(' ')[2].split('"')[1]
        #print record_split
        stopStart=record_split[3]
        stopStop=record_split[4] 
        stopStrand=record_split[6]
 
        stopCoord=stopStart+"_"+stopStop+"_"+stopStrand

        stop_coord[stopID]=stopCoord
  
        #print stopID, stop_coord[stopID]


    for key in gold_tx:
        for tx in gold_tx[key]:
            if key in gold_coord:
                #print "key", key  
                #print "gold coord", gold_coord[key].split('_')
                goldBegin=gold_coord[key].split('_')[0]
                goldEnd=gold_coord[key].split('_')[1]
                goldStr=gold_coord[key].split('_')[2]   
                #print "BEGIN", goldBegin
                #print "END",  goldEnd
                #print "STR",  goldStr
            if tx in stop_coord:
                #print "TX", tx
                #print "KEY", key
                #print "stop coord", stop_coord[tx].split('_')
                stopBegin=stop_coord[tx].split('_')[0]
                stopEnd=stop_coord[tx].split('_')[1]
                stopStr=stop_coord[tx].split('_')[2]
                #print "BEGIN", stopBegin
                #print "END",  stopEnd
                #print "STR",  stopStr
                if goldStr == "+" and stopStr == "+":
                    dist=int(stopBegin)-int(goldBegin)
                    item=tx+"\t"+str(dist)
 
                    if key not in gold_dist:
                        gold_dist[key]=[item]
                    else:
                        gold_dist[key].append(item) 
                    #print key, len(gold_dist)

                if goldStr == "-" and stopStr == "-":
                    dist=int(stopEnd)-int(goldEnd)
                    item=tx+"\t"+str(dist)
 
                    if key not in gold_dist:
                        gold_dist[key]=[item]
                    else:
                        gold_dist[key].append(item) 
                    #print key, len(gold_dist)
        

    for k in gold_dist:
        for e in gold_dist[k]:
            nb=e.split('\t')[1]
            l.append(abs(int(nb)))
        #print "L", l
        take=min(l)
        #print "TAKE", take
        indx=l.index(take)
        #print "INDX", indx
        #print "CHCK", l[indx]
        gold_min[k]=gold_dist[k][indx]
        #print "GOLD_MIN", k, gold_min[k]                  
        l=[]
   
    f=open(outfile, 'w')
    for kyz in gold_dist:
        for sth in gold_dist[kyz]:
            f.write('%s\t' % kyz)
            f.write('%s\n' % sth)
    f.close()  


    fil=open(mini, 'w')
    for z in gold_min:
        fil.write('%s\t' % z)
        fil.write('%s\n' % gold_min[z])
    fil.close()  
               
                 
get_distance()
