#!/usr/bin/python

__author__="BU"


"""This script selects dominant transcripts for a given gene based on its expression threshold and threshold of fold change between dominant transcript and next highly expressed transcript."""

# Usage python dominant.transcript.analysis.py -i FLUXoutput.gtf -o output.txt -rpkm N -FC 

from os import sys
import getopt
import heapq

# Store input and output file

infile=''
outfile=''
rpkm_value=''
fold_change=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:f:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
       rpkm_value=a
    if o == '-f':
       fold_change=a
       
print ("Input file: %s \nOutput file: %s \nRPKM threshold: %s \nFC threshold: %s" % (infile,outfile,rpkm_value,fold_change) )

# Body of dt function

def dominant_transcript():
    
    gene_trans={}
    trans_exp={}
    rpkm_set=[]
    #tras_id_set=[]
    dominants={}

    flux_output=open(infile, 'r')
    
    for line in flux_output:
        line_split=line.split('\t')
        #print 'line_split', '\n', line_split
        cigar=line_split[8].split(';')
         
        for elem in cigar:
            #print 'elem', '\n', elem
            if elem.startswith('gene_id'):
                gene_id=elem.split('"')[1]
                #print 'gene_id', '\n', gene_id
            if elem.startswith(' transcript_id'):
                trans_id=elem.split('"')[1]
                #print 'trans_id', '\n', trans_id
            if elem.startswith(' RPKM'):
                rpkm=elem.split('"')[1]
                #print 'rpkm', '\n', rpkm
                
                if gene_id not in gene_trans:
                    gene_trans[gene_id]=[trans_id]
                else:
                    gene_trans[gene_id].append(trans_id)
                #print 'GT', '\n', gene_id, gene_trans[gene_id]

                if trans_id not in trans_exp:
                    trans_exp[trans_id]=[rpkm]
                else: 
                    trans_exp[trans_id].append(rpkm) 
                #print 'TRANS_EXP', '\n', trans_id, trans_exp[trans_id]

    for gene in gene_trans:
        trans_per_locus=gene_trans[gene]
        #print 'trans_per_locus', '\n', trans_per_locus 
        for trans in trans_per_locus:
            rpkm_set.append(trans_exp[trans][0])
        highly_expressed=heapq.nlargest(2, rpkm_set)
        #print 'RPKM_SET', '\n', rpkm_set
        #print 'Highly expressed', '\n', highly_expressed
        #print 'Highly expressed 0', '\n', float(highly_expressed[0])
        #print  'FC', '\n', float(fold_change)
        if float(highly_expressed[0]) >= float(rpkm_value):
            if len(highly_expressed) == 1:
                position=rpkm_set.index(highly_expressed[0])
                dominants[gene]=(trans_per_locus[position],rpkm_set[position])
            if len(highly_expressed) > 1:
                if float(highly_expressed[1]) != 0:
                    if float(highly_expressed[0])/float(highly_expressed[1]) >= float(fold_change):
                        position=rpkm_set.index(highly_expressed[0])
                        #print 'Pos', '\n', position
                        dominants[gene]=(trans_per_locus[position],rpkm_set[position])
                if float(highly_expressed[1]) == 0:
                    position=rpkm_set.index(highly_expressed[0])
                    dominants[gene]=(trans_per_locus[position],1000)   
                    print 'dominants', '\n', gene, dominants[gene]
                   
        rpkm_set=[]












dominant_transcript()








