#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
        help="GTF/GTF. No stdin")
parser.add_option('-o', help='Output GTF file with exchanged gene ids')
parser.add_option('-r', help='Tab-separated list of transcript and corresponding gene ids to replace.')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r ref " % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a 
       
print ("Input file : %s \nOutput file: %s \nRef file: %s" % (infile,outfile,ref))


def exchange_gene_ids():

    gtf={}
    tsv={}
    exchanged={}
    normal={}

    gtf_file=open(infile, 'r')
    for line in gtf_file:
        line_split=line.split("\n")[0].split("\t")
        typ=line_split[2]

        if typ == "exon":

            chrNum=line_split[0]
           
            if chrNum not in gtf:
                gtf[chrNum]=[line.split("\n")[0]]
            else:
                gtf[chrNum].append(line.split("\n")[0])
 
            #print chrNum, gtf[chrNum]

    tsvFile=open(ref, "r")
    for rec in tsvFile: 
        rec_split=rec.split("\t")
        patch=rec_split[0]
        patchP=rec_split[1].split("\n")[0]
  
        tsv[patch]=patchP

        #print patch, tsv[patch] 

    for key in gtf:
        if key in tsv:
            for value in gtf[key]:
                val_split=value.split("\t")
                chrN=val_split[0]
                sth=val_split[1]
                typ=val_split[2]
                start=val_split[3]  
                stop=val_split[4]
                dot1=val_split[5]
                strand=val_split[6]
                dot2=val_split[7]
                cigar=val_split[8].split("\n")[0]
                #print cigar
                geneID=cigar.split(" ")[1]
                txID=cigar.split(" ")[3]                
                new_record=(tsv[key]+"\t"+sth+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+' "'+geneID+" "+"transcript_id"+" "+txID)

                #print "TYD",key, new_geneID
                if key not in exchanged:
                    exchanged[key]=[new_record]
                else:
                    exchanged[key].append(new_record)

        if key not in tsv:
            for value in gtf[key]:          
                val_split=value.split("\t")
                chrN=val_split[0]
                sth=val_split[1]
                typ=val_split[2]
                start=val_split[3]  
                stop=val_split[4]
                dot1=val_split[5]
                strand=val_split[6]
                dot2=val_split[7]
                cigar=val_split[8].split("\n")[0]
                #print cigar
                geneID=cigar.split(" ")[1]
                txID=cigar.split(" ")[3]                
                new_record=(chrN+"\t"+sth+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+' "'+geneID+" "+"transcript_id"+" "+txID)

                if key not in exchanged:
                    exchanged[key]=[new_record]
                else:
                    exchanged[key].append(new_record)
                                                   
    f=open(outfile, "w")
    for k in exchanged:
        for v in exchanged[k]:
            f.write('%s\n' % v)
    f.close() 


exchange_gene_ids()

