#!/usr/bin/python

__author__="BU"


"""This script exchanges """

# Usage python gff3Togtf.py -i annotation.gff3 -o output.gtf 

from os import sys
import getopt
import heapq
from optparse import OptionParser

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="Annotation in gff")
parser.add_option("-o",  help='Output gtf file')
parser.add_option("-r",  help="tab-separated file with readID, str")

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a


print ("Input file: %s \nOutput file: %s \nRef file: %s" % (infile,outfile,ref))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------

def exchangeGff():
   
    gff={}
    tsv={}
    exchanged={}

    gffFile=open(infile, "r")
    for line in gffFile:
        split=line.split("\t")
        geneID=split[8].split('"')[1]
  
        if geneID not in gff:
            gff[geneID]=[line]
        else:
            gff[geneID].append(line)

    tsvFile=open(ref, "r")
    for record in tsvFile: 
        rec_split=record.split("\t")
        readID=rec_split[0]
        strand=rec_split[1].split("\n")[0]
  
        tsv[readID]=strand


    for key in tsv:
        if key in gff:
            for value in gff[key]:
                val_split=value.split("\t")
                chrN=val_split[0]
                sth=val_split[1]
                typ=val_split[2]
                start=val_split[3]  
                stop=val_split[4]
                dot1=val_split[5]
                new_strand=tsv[key]
                dot2=val_split[7]
                cigar=val_split[8].split("\n")[0]
                new_record=(chrN+"\t"+sth+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+new_strand+"\t"+dot2+"\t"+cigar)

                if key not in exchanged:
                    exchanged[key]=[new_record]
                else:
                    exchanged[key].append(new_record)

    f=open(outfile, "w")
    for k in exchanged:
        for v in exchanged[k]:
            f.write('%s\n' % v)
    f.close() 

exchangeGff() 

