#!/usr/bin/python

__author__="BU"


"""This script exchanges transcript id from column2 to column1 form the duplicate_transcripts_gencode19.xls sent by Jen Harrow"""

# Usage python dominant.transcript.analysis.py -i FLUXoutput.gtf -o output.txt -rpkm N -FC 

from os import sys
import getopt
import heapq

# Store input and output file

infile=''
outfile=''
list_elem=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        list_elem=a

print ("Input file: %s \nOutput file: %s \nList: %s" % (infile,outfile,list_elem))
def exchange():
 
    trans_gene={}
    trans_fpkm={}
    trans1to2={}
    exchanged={}
    qc=[]
    cuff_output=open(infile, 'r')
    for line in cuff_output:
        line_split=line.split('\t')
        if line_split[0] != 'tracking_id':
            trans_id=line_split[0]
            #print 'TRANS_ID', trans_id
        if line_split[3] != 'gene_id':
            gene_id=line_split[3]
            #print 'GENE_ID', line_split[3]
        if line_split[9] != 'FPKM':
            fpkm=line_split[9]
            #print 'FPKM', fpkm
            
            trans_gene[trans_id]=gene_id

            trans_fpkm[trans_id]=fpkm
             

    list_exchange=open(list_elem, 'r')
    for record in list_exchange:
        record_split=record.split('\t')
        #print 'RS', record_split
        trans_index1=record_split[0]
        #print 'TI1', trans_index1
        trans_index2=record_split[1].split('\n')[0]  
        #print 'TI2', trans_index2

        trans1to2[trans_index2]=trans_index1



    for key in trans_gene:
        if key in trans1to2:  
            exchanged[key]=(trans1to2[key], trans_gene[key], trans_fpkm[key])
            #print 'I am exchanging!!!'
            qc.append(key)
            #print len(qc)
        else:
            exchanged[key]=(key, trans_gene[key], trans_fpkm[key])
        #print 'EX', key, exchanged[key]

    f=open(outfile, 'w')
    for k in exchanged: 
        #print 'K-E', exchanged[k]
        for elem in exchanged[k]:
            f.write('%s\t' % elem)
        f.write('\n')     
        
exchange()

