#!/usr/bin/python

__author__="BU"


"""This script contains only one fucntion calles order_exons, which orders the exons for given transcript"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is sorted gtf file. No stdin")
parser.add_option('-o', help='Output is the tsv file with the exon details')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of exon_order function 

def exon_order():

    exons_trans={}
    order={}

    gtf=open(infile)
    for line in gtf:
       line_split = line.strip().split('\t')
       #print line_split
       record_type = line_split[2]
       if record_type.startswith('exon'):
           chrom=line_split[0]
           #print 'CHROM', chrom
           start=line_split[3]
           #print 'START', start
           stop=line_split[4]
           #print 'STOP', stop
           strand=line_split[6]
           #print 'STR', strand
           #print "element_set", line_split[9]
           element_set = line_split[8].strip().split(";")
            
           for element in element_set:
               if element.strip().split(" ")[0].startswith('transcript_id'):
                   trans_id=element.strip().split('"')[1]
                   #print 'TRANS ID', trans_id

                   if trans_id not in exons_trans:
                        exons_trans[trans_id]=[chrom+'_'+start+'_'+stop+'_'+strand]
                   else:
                       exons_trans[trans_id].append(chrom+'_'+start+'_'+stop+'_'+strand)
                   #print 'RESULTS',  trans_id, exons_trans[trans_id]
                   #print len(exons_trans.keys())

    f=open(outfile, 'w')
    for key in exons_trans:
         strd=exons_trans[key][0].split('_')[3]
         if strd == "+":
             exon_list=sorted(exons_trans[key])
         if strd == "-":
             exon_list=sorted(exons_trans[key], reverse=True) 
         #print 'EXON LIST', exon_list, "\nSORTED:", sorted(exon_list)    
         for item in exon_list:
             pos=1 + exon_list.index(item)
             posF="exon_" + str(pos)
             #print key, item, pos
             for element in item.split('_'):
                 #print element
                 f.write('%s\t' % element)
             f.write('%s\t' % key)
             f.write('%s\t' % item)
             f.write('%s\n' % posF)
    f.close()     

              

exon_order()

