#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is intersectBed output. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-r', help='Reference transcript ids')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a 

print ("Input file : %s \nOutput file: %s \nReference ids %s" % (infile,outfile, ref))

def fill():

    bedout={}
    reference={}
    selected={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split
        #chrom=line_split[0]
        #start=line_split[1]
        #stop=line_split[2]
        #strand=line_split[3]
        uniq_id=line_split[4]
        #reads=line_split[5]
        #length=line_split[6]

        bedout[uniq_id]=line.split('\n')[0]
 

    ref_file=open(ref, 'r')
    for lines in ref_file:
        lines_split=lines.split('\t')
        chrom=lines_split[0]
        start=lines_split[1]
        stop=lines_split[2]
        strand=lines_split[3]
        uniq_ids=lines_split[4].split('\n')[0]
        reads='0'
        length=str(float(stop)-float(start))
        #print length 

        reference[uniq_ids]=chrom+"\t"+start+"\t"+stop+"\t"+strand+"\t"+uniq_ids+"\t"+reads+"\t"+length
        #print  uniq_ids, reference[uniq_ids]

    for key in reference:
        if key not in bedout:
            selected[key]=reference[key]
        else:
            selected[key]=bedout[key]

    f=open(outfile, 'w')
    for keys in selected:
        f.write('%s\n' % selected[keys])
    f.close()

fill()     
         
        
