import os

def run(file_name):
    inp = open(file_name, 'r')
    out = open('filtered/'+file_name, 'w')

    sonds = {}
    markers = {}

    for line in inp:

        columns = line.split('\t')
        if len(columns) != 30 or line.startswith('"Block"'): continue
        
        name = columns[3].replace('"', '')
        F650 = float(columns[9])
        B650 = float(columns[13])

        if name.startswith('Alex'): 
            if markers.has_key(name): markers[name].append((F650,B650))
            else: markers[name] = [(F650,B650)]
            continue

        tmp = name[:3]        
        if tmp not in ('hsa', 'rno', 'mmu'): continue

        if sonds.has_key(name): sonds[name].append((F650,B650))
        else: sonds[name] = [(F650,B650)]    

    calc_avg(sonds) 
    calc_avg(markers)
    result = select_sonds(sonds)    

    for m in markers:
        out.write(m + ',' + str(markers[m][0]) + ',' + str(markers[m][1]) + '\n')

    keys = result.keys()
    keys.sort()

    for k in keys:
        if len(result[k]) == 3:            
            out.write(k + ',' + str(result[k]['hsa'][0]) + ',' + str(result[k]['hsa'][1]) + ',' + str(result[k]['rno'][0]) + ',' + str(result[k]['rno'][1]) + ',' + str(result[k]['mmu'][0])+ ',' + str(result[k]['mmu'][1]) + '\n')

    inp.close()
    out.close()
    

def calc_avg(sonds):
    for key in sonds:
        sonds[key][0] = round(sum(sonds[key][0]) / float(len(sonds[key][0])),2)
        sonds[key][1] = round(sum(sonds[key][1]) / float(len(sonds[key][1])),2)


def select_sonds(sonds):
    result = {}

    for key in sonds:        
        org = key[:3]
        name = key[4:]       
        if result.has_key(name): result[name][org] = sonds[key]
        else: result[name] = {org: sonds[key]}

    return result


########################################3

if __name__ == '__main__':    
    if not os.path.exists('filtered'): os.mkdir('filtered')
    for f in os.listdir('.'): 
        if f.endswith('.gpr'):
            run(f)            
