#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is SORTED gtf. No stdin")
parser.add_option('-o', help='Output file: txID, upstream exon, exon of interest, downstrem exon')
parser.add_option('-r', help='List of exons for which flanking ones should be selected')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''
# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r reference" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a
        
print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def flankingExons():

    tx_exon={}
    reference=[]
    flanking={}
     
    gtf=open(infile, 'r')
    for line in gtf:
        line_split=line.split("\t")
        #print line_split
        if line_split[2]=="exon":
             chrN=line_split[0]
             start=line_split[3]
             stop=line_split[4]
             strand=line_split[6]
             txID=line_split[8].split(" ")[3].split('"')[1]
             coord=chrN+"_"+start+"_"+stop+"_"+strand
 
             if txID not in tx_exon:
                 tx_exon[txID]=[coord]
             else:
                 tx_exon[txID].append(coord)

    refFile=open(ref, 'r')
    for record in refFile:
        reference.append(record.split('\n')[0])


    for exon in reference:
        #print exon
        for key in tx_exon:
            if exon in tx_exon[key]:
                #print tx_exon[key]
                pos=tx_exon[key].index(exon)
                size=len(tx_exon[key])-1
                #print 'POS', pos
                #print 'SIZE', size
                 
                if pos == 0:
                    #print 'POS==0'
                    up="NA"
                    down=tx_exon[key][pos+1]
                    exon_set=up+'\t'+exon+'\t'+down

                    if key not in flanking:
                        flanking[key]=[exon_set]
                    else: 
                        flanking[key].append(exon_set) 

                if pos < size:
                    #print 'POS<LEN'
                    up=tx_exon[key][pos-1]
                    down=tx_exon[key][pos+1]
                    exon_set=up+'\t'+exon+'\t'+down
 
                if pos == size:
                    #print 'POS==LEN'
                    up=tx_exon[key][pos-1]
                    down="NA"
                    exon_set=up+'\t'+exon+'\t'+down

  
                if key not in flanking:
                    flanking[key]=[exon_set]
                else: 
                    flanking[key].append(exon_set) 

    f=open(outfile, 'w')
    for k in flanking:
        for item in flanking[k]:
            f.write('%s\t' % k)
            f.write('%s\n' % item)
    f.close()             


flankingExons()


                

