library(ggplot2)

#crg_ids=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/our.decoded.labexpids.trimm.txt', header=F)
#ebi_ids=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/ebi.decoded.labexpids.trimm.txt', header=F)

# Star 2 

flux_star2=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/decoded.flux.appris.intersection.2.txt')
int_fs2=as.vector(flux_star2[,4])

flux_star_gl2=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/decoded.flux.appris.intersection.gene.level.2.txt')
int_gl_fs2=flux_star_gl2[,4]

df_fs2=data.frame(label=c(1:length(int_fs2)), dat=int_fs2, type='# Flux dominant transcripts overlaping with Appris')
df_gl_fs2=data.frame(label=c(1:length(int_gl_fs2)), dat=int_gl_fs2, type='# Genes for which both methods report dominant transcripts')
df_flux2=rbind(df_fs2, df_gl_fs2)

breaks=seq(1, length(df_fs2$label), by=1)
png('flux.vs.appris.star2.no.rpkm.df2.GGPLOT.png', bg = "white", width = 1600, height = 1000)
ggplot(data=df_flux2, aes(x=label, y=dat, fill=type)) + geom_bar(stat="identity", position=position_dodge())+ ylab('Counts') + xlab ('ENCODE2 Samples') + ggtitle('Flux vs. Appris (FPKM >= 0, Dominance factor >=2, STAR2 mappings)') + scale_fill_manual(values=c("slategray3","#999999"))+scale_x_discrete(breaks=breaks, labels=as.character(breaks))+ theme(axis.text.x = element_text(size = 10, colour = "black", angle=90), axis.text.y = element_text(size = 10,  colour = "black"), legend.text = element_text(size=14), plot.title = element_text(size = 22), legend.title =element_text(size=0, color="white"), axis.title.x = element_text(size = 16), axis.title.y = element_text(size = 20), legend.text.align=0.5, strip.text.x=element_text(size=12), strip.text.y=element_text(size=8))+ theme(legend.position="top")
dev.off()


# Star 2
library(ggplot2)

flux_star5=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/decoded.flux.appris.intersection.5.txt')
int_fs5=as.vector(flux_star5[,4])

flux_star_gl5=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/decoded.flux.appris.intersection.gene.level.5.txt')
int_gl_fs5=flux_star_gl5[,4]

df_fs5=data.frame(label=c(1:length(int_fs5)), dat=int_fs5, type='# Flux dominant transcripts overlaping with Appris')
df_gl_fs5=data.frame(label=c(1:length(int_gl_fs5)), dat=int_gl_fs5, type='# Genes for which both methods report dominant transcripts')
df_flux5=rbind(df_fs5, df_gl_fs5)

breaks=seq(1, length(df_fs5$label), by=1)

png('flux.vs.appris.star2.no.rpkm.df5.GGPLOT.png', bg = "white", width = 1600, height = 1000)
ggplot(data=df_flux5, aes(x=label, y=dat, fill=type)) + geom_bar(stat="identity", position=position_dodge())+ ylab('Counts') + xlab ('ENCODE2 Samples') + ggtitle('Flux vs. Appris (FPKM >= 0, Dominance factor >=5, STAR2 mappings)') + scale_fill_manual(values=c("slategray3", "#999999"))+scale_x_discrete(breaks=breaks, labels=as.character(breaks))+ theme(axis.text.x = element_text(size = 10, colour = "black", angle=90), axis.text.y = element_text(size = 10,  colour = "black"), legend.text = element_text(size=14), plot.title = element_text(size = 22), legend.title =element_text(size=0, color="white"), axis.title.x = element_text(size = 16), axis.title.y = element_text(size = 20), legend.text.align=0.5, strip.text.x=element_text(size=12), strip.text.y=element_text(size=8))+ theme(legend.position="top")
dev.off()

# Tophat 2
library(ggplot2)

flux_tophat2=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/sorted.decoded.flux.appris.intersection.tophat.2.txt')
int_fs2=as.vector(flux_tophat2[,2])

flux_tophat_gl2=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/sorted.flux.appris.intersection.tophat.gene.level.2.txt')
int_gl_fs2=flux_tophat_gl2[,2]

df_fs2=data.frame(label=c(1:length(int_fs2)), dat=int_fs2, type='# Flux dominant transcripts overlaping with Appris')
df_gl_fs2=data.frame(label=c(1:length(int_gl_fs2)), dat=int_gl_fs2, type='# Genes for which both methods report dominant transcripts')
df_flux2=rbind(df_fs2, df_gl_fs2)

breaks=seq(1, length(df_fs2$label), by=1)
png('flux.vs.appris.tophat.no.rpkm.df2.GGPLOT.png', bg = "white", width = 1600, height = 1000)
ggplot(data=df_flux2, aes(x=label, y=dat, fill=type)) + geom_bar(stat="identity", position=position_dodge())+ ylab('Counts') + xlab ('ENCODE2 Samples') + ggtitle('Flux vs. Appris (FPKM >= 0, Dominance factor >=2, TopHat mappings)') + scale_fill_manual(values=c("hotpink","#999999"))+scale_x_discrete(breaks=breaks, labels=as.character(breaks))+ theme(axis.text.x = element_text(size = 10, colour = "black", angle=90), axis.text.y = element_text(size = 10,  colour = "black"), legend.text = element_text(size=14), plot.title = element_text(size = 22), legend.title =element_text(size=0, color="white"), axis.title.x = element_text(size = 16), axis.title.y = element_text(size = 20), legend.text.align=0.5, strip.text.x=element_text(size=12), strip.text.y=element_text(size=8))+ theme(legend.position="top")
dev.off()

# Tophat 5

library(ggplot2)

flux_tophat5=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/sorted.decoded.flux.appris.intersection.tophat.5.txt')
int_fs5=as.vector(flux_tophat5[,2])

flux_tophat_gl5=read.table('/users/rg/buszczynska/Projects/dominant.transcripts/flux.star2/sorted.flux.appris.intersection.tophat.gene.level.5.txt')
int_gl_fs5=flux_tophat_gl5[,2]

df_fs5=data.frame(label=c(1:length(int_fs5)), dat=int_fs5, type='# Flux dominant transcripts overlaping with Appris')
df_gl_fs5=data.frame(label=c(1:length(int_gl_fs5)), dat=int_gl_fs5, type='# Genes for which both methods report dominant transcripts')
df_flux5=rbind(df_fs5, df_gl_fs5)

breaks=seq(1, length(df_fs5$label), by=1)
png('flux.vs.appris.tophat.no.rpkm.df5.GGPLOT.png', bg = "white", width = 1600, height = 1000)
ggplot(data=df_flux5, aes(x=label, y=dat, fill=type)) + geom_bar(stat="identity", position=position_dodge())+ ylab('Counts') + xlab ('ENCODE2 Samples') + ggtitle('Flux vs. Appris (FPKM >= 0, Dominance factor >=5, TopHat mappings)') + scale_fill_manual(values=c("hotpink","#999999"))+scale_x_discrete(breaks=breaks, labels=as.character(breaks))+ theme(axis.text.x = element_text(size = 10, colour = "black", angle=90), axis.text.y = element_text(size = 10,  colour = "black"), legend.text = element_text(size=14), plot.title = element_text(size = 22), legend.title =element_text(size=0, color="white"), axis.title.x = element_text(size = 16), axis.title.y = element_text(size = 20), legend.text.align=0.5, strip.text.x=element_text(size=12), strip.text.y=element_text(size=8))+ theme(legend.position="top")
dev.off()


