#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bedCoverage output. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-t', help='Total number of reads within bam')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
total_reads=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:t:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-t':
        total_reads=a 

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def get_rpkm():

    sample=[]
    ids_reads={}
    ids_length={}
    final={}

    bed_file=open(infile, 'r')
    for line in bed_file:
        line_split=line.split('\t')
        #print 'LS', line_split
        #start=line_split[1]
        #print 'START', start
        #stop=line_split[2]
        ids=line_split[0]  
        length=line_split[1]          
        #print 'len', length
                   
        #print 'IDS', ids 
        reads=line_split[2].split('\n')[0]
        #print 'READS', reads
        
        ids_reads[ids]=reads
     
        ids_length[ids]=length
  
    for key in ids_reads:
        rpkm=(1e+09*float(ids_reads[key]))/(float(ids_length[key])*float(total_reads))
        #print 'READ', ids_reads[key]
        #print 'RPKM', rpkm
        fpkm=str(2*rpkm)

        final[key]=(str(ids_length[key]), str(ids_reads[key]), fpkm)

    header="Length"+'\t'+"Reads"+'\t'+"FPKM"

    f=open(outfile, 'w')
    f.write('%s\n' % header)
    for keys in final:
        f.write('%s\t' % keys)
        for value in final[keys]:
            f.write('%s\t' % value) 
        f.write('\n')
    f.close()

get_rpkm()


