#!/usr/bin/python

__author__="BU"


"""This script converts gff3 to gtf"""

# Usage python gff3Togtf.py -i annotation.gff3 -o output.gtf 

from os import sys
import getopt
import heapq
from optparse import OptionParser

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="Annotation in gff3")
parser.add_option("-o",  help='Output gtf file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file: %s \nOutput file: %s" % (infile,outfile))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------

def gff3Togtf():
   
    gtf={}

    gff3=open(infile, "r")
    for line in gff3:
        if line != '###\n':
            split=line.split("\t")
            if split[2]=="gene":
                chrN=split[0]
                add=split[1]
                typ=split[2]
                start=split[3]
                stop=split[4]
                dot1=split[5]
                strand=split[6]
                dot2=split[7] 
                gene_id=split[8].split("=")[1].split('\n')[0]
                record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+gene_id+'"'"; "+"transcript_id"+" "+'"'+gene_id+'"'";")
           
                if gene_id not in gtf:
                    gtf[gene_id]=[record]
                else:
                    gtf[gene_id].append(record)     

            if split[2]=="exon":
                chrN=split[0]
                add=split[1]
                typ=split[2]
                start=split[3]
                stop=split[4]
                dot1=split[5]
                strand=split[6]
                dot2=split[7] 
                gene_id=split[8].split(";")[0].split("=")[1].split("T")[0]
                trans_id=split[8].split(";")[0].split("=")[1]
                record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+gene_id+'"'"; "+"transcript_id"+" "+'"'+trans_id+'"'";")
           
                if gene_id not in gtf:
                    gtf[gene_id]=[record]
                else:
                    gtf[gene_id].append(record)     
          
            if split[2]=="CDS":
                chrN=split[0]
                add=split[1]
                typ=split[2]
                start=split[3]
                stop=split[4]
                dot1=split[5]
                strand=split[6]
                dot2=split[7] 
                gene_id=split[8].split(";")[0].split("=")[1].split("T")[0]
                trans_id=split[8].split(";")[0].split("=")[1]
                record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+gene_id+'"'"; "+"transcript_id"+" "+'"'+trans_id+'"'";")
           
                if gene_id not in gtf:
                    gtf[gene_id]=[record]
                else:
                    gtf[gene_id].append(record)    

            if split[2]=="mRNA":
                chrN=split[0]
                add=split[1]
                typ=split[2]
                start=split[3]
                stop=split[4]
                dot1=split[5]
                strand=split[6]
                dot2=split[7] 
                gene_id=split[8].split(";")[0].split("=")[1].split("T")[0]
                trans_id=split[8].split(";")[0].split("=")[1]
                record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+gene_id+'"'"; "+"transcript_id"+" "+'"'+trans_id+'"'";")
           
                if gene_id not in gtf:
                    gtf[gene_id]=[record]
                else:
                    gtf[gene_id].append(record) 
            #print gene_id, gtf[gene_id]

    f=open(outfile, "w")

    for key in gtf:
        for v in gtf[key]:
            f.write('%s\n' % v)
    f.close() 

gff3Togtf()
