#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
        help="The input format is .gtf file with splice junction coordinates, the output of RT-PCR-Seq pipeline. No stdin")
parser.add_option('-o', help='Output file')
options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
 
print ("Input file : %s \nOutput file: %s" % (infile,outfile))

# ========================
# Body of GET_SJ function
# ========================

def getPrimers():

    primers={}

    gtf_file=open(infile, 'r')
    for line in gtf_file:
        line_split=line.split('\n')[0].split('\t')
        chrN=line_split[0] 
        strand=line_split[5]   
        cigar=line_split[6]
        cigar_split=cigar.split(';')
        for item in cigar_split:
            if item.startswith(' transcript_id'):
                trans=item.split('"')[1]
            if item.startswith(' sj_id'):
                sj=item.split('"')[1]
            if item.startswith(' Primer_F_id'):
                Fid=item.split('"')[1]
            if item.startswith(' Primer_R_id'):
                Rid=item.split('"')[1]
            if item.startswith(' Primer_F_pos'):
                Fcoord=item.split(' ')[2]
                Fstart=Fcoord.split(',')[0].split('"')[1]
                Fstop=Fcoord.split(',')[1].split('"')[1]
            if item.startswith(' Primer_R_pos'): 
                Rcoord=item.split(' ')[2]
                Rstart=Rcoord.split(',')[0].split('"')[1]
                Rstop=Rcoord.split(',')[1].split('"')[1]
            if  item.startswith(' Primer_F_gc'):
                Fgc=item.split('"')[1]
            if  item.startswith(' Primer_R_gc'):
                Rgc=item.split('"')[1]
            if  item.startswith(' Primer_F_tm'):
                Ftm=item.split('"')[1]
            if  item.startswith(' Primer_R_tm'):
                Rtm=item.split('"')[1]

                FRecord=(chrN+"\t"+"HAVANA"+"\t"+"exon"+"\t"+Fstart+"\t"+Fstop+"\t"+"."+"\t"+strand+"\t"+"."+"\t"+"gene_id"+" "+'"'+trans+'"'"; "+"transcript_id"+" "+'"'+Fid+'"'"; "+"Primer_F_gc"+" "+'"'+Fgc+'"'"; "+"Primer_F_tm"+" "+'"'+Ftm+'"'"; "+"sj_id"+" "+'"'+sj+'"'";")
                RRecord=(chrN+"\t"+"HAVANA"+"\t"+"exon"+"\t"+Rstart+"\t"+Rstop+"\t"+"."+"\t"+strand+"\t"+"."+"\t"+"gene_id"+" "+'"'+trans+'"'"; "+"transcript_id"+" "+'"'+Rid+'"'"; "+"Primer_R_gc"+" "+'"'+Rgc+'"'"; "+"Primer_R_tm"+" "+'"'+Rtm+'"'"; "+"sj_id"+" "+'"'+sj+'"'";")
            
                primers[Fid]=FRecord 
                primers[Rid]=RRecord  
                #print Fid, primers[Fid]

    f=open(outfile, "w")
    for key in primers:
        f.write('%s\n' % primers[key])
    f.close() 
   
getPrimers()
