#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="GTF file containing exons. No stdin")
parser.add_option('-o', help='output file')
parser.add_option('-r',help='file containing reference exons identifiers, for which the position must be determined')
options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref_id=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a

print ("Input file : %s \nOutput file: %s \nReference ids: %s" % (infile,outfile,ref_id))

# ========================
# Body of functions
# ========================
    
def exonizer():

    trans_exon_frwd={}
    trans_exon_rew={}
    reference=[]
    exon_pos={}

    gtf=open(infile, 'r')
    for line in gtf:
        line_split=line.split('\t')
        #print line_split
        if line_split[2] == 'exon':
            strand=line_split[6]
            cigar_split=line_split[8].split(';')
            #print cigar_split
            for item in cigar_split:
                if item.startswith(' transcript_id'):
                    trans_id=item.split('"')[1].split('.')[0]
                    #print trans_id
                if item.startswith('  exon_id'):
                    exon_id=item.split('"')[1].split('.')[0]
                    #print exon_id
                    
                    if strand == '+':
                    
                        if trans_id not in trans_exon_frwd:
                            trans_exon_frwd[trans_id]=[exon_id]
                        else:
                            trans_exon_frwd[trans_id].append(exon_id)  
 
                    if strand == '-': 

                        if trans_id not in trans_exon_rew:
                            trans_exon_rew[trans_id]=[exon_id]
                        else:
                            trans_exon_rew[trans_id].append(exon_id)  
  
      

    ref=open(ref_id, 'r')
    for record in ref:
        reference.append(record.split('\n')[0])
        #print reference

# FORWARD STRAND

    for key in trans_exon_frwd:
        #print 'LIST', trans_exon_frwd[key] 
        for value in trans_exon_frwd[key]:
            #print 'VALUE', value 
            if value in reference:
                pos=trans_exon_frwd[key].index(value)+1
                #print pos
                if pos == 1 and pos != len(trans_exon_frwd[key]):

                    if value not in exon_pos:
                        exon_pos[value]=['INITIAL']       
                    else:
                        exon_pos[value].append('INITIAL')

                if pos == len(trans_exon_frwd[key]) and pos != 1: 
                    if value not in exon_pos:
                        exon_pos[value]=['TERMINAL']       
                    else:
                        exon_pos[value].append('TERMINAL')

                if pos == 1 and pos == len(trans_exon_frwd[key]):
                
                    if value not in exon_pos:
                        exon_pos[value]=['MONO']       
                    else:
                        exon_pos[value].append('MONO')

                if pos != 1 and pos != len(trans_exon_frwd[key]):

                    if value not in exon_pos:
                        exon_pos[value]=['OTHER']       
                    else:
                        exon_pos[value].append('OTHER')
 
# FORWARD STRAND

    for kyz in trans_exon_rew:
        for val in trans_exon_rew[kyz]:
            #print 'VALUE', value 
            if val in reference:
                poz=trans_exon_rew[kyz].index(val)+1
          
                if poz == 1 and poz != len(trans_exon_rew[kyz]):

                    if val not in exon_pos:
                        exon_pos[val]=['TERMINAL']       
                    else:
                        exon_pos[val].append('TERMINAL')

                if poz == len(trans_exon_rew[kyz]) and poz != 1:

                    if val not in exon_pos:
                        exon_pos[val]=['INITIAL']       
                    else:
                        exon_pos[val].append('INITIAL')

                if poz == 1 and poz == len(trans_exon_rew[kyz]):
                
                    if val not in exon_pos:
                        exon_pos[val]=['MONO']       
                    else:
                        exon_pos[val].append('MONO')

                if poz != 1 and poz != len(trans_exon_rew[kyz]):

                    if val not in exon_pos:
                        exon_pos[val]=['OTHER']       
                    else:
                        exon_pos[val].append('OTHER')
      
            

    f=open(outfile, 'w')
    for keys in exon_pos:
        for elem in set(exon_pos[keys]):
            f.write('%s\t' % keys)
            f.write('%s\n' % elem)
    f.close()
  
exonizer()  
 
