#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
        help="The input format is bedtools intersect output with -wa and -wb. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-v', help='Add variable to the output file')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
var='' 
# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:v:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-v':
        var=a 
 
print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def get_location():

    loc=[]

    bed_file=open(infile, 'r')
    for line in bed_file:
        line_split=line.split('\n')[0].split('\t')
        #print line_split
        readStart=int(line_split[3])
        readStop=int(line_split[4])
        txStart=int(line_split[10])
        txStop=int(line_split[11])
        txStr=line_split[14]
        #print 'readStart', readStart
        #print 'readStop', readStop 
        #print 'txStart', txStart
        #print 'txStop', txStop
        #print 'txStr', txStr
        if txStr == "+":
            #print line_split
            readAv=readStart+(readStop - readStart)/2
            #print 'readAv', readAv
            segment=int(readAv-txStart)
            txLength=int(txStop-txStart)
            txLoc=(float(segment) / txLength) * 100
            #print 'segment', segment
            #print 'txLength', txLength
            #print 'txLoc', txLoc
            if segment >= 0 and txLength >= segment:
                loc.append(str(txLoc)+'\t'+'Body'+'\t'+txStr+'\t'+var+'\n')        
                #print 'YES in the body'
            if segment < 0:
                loc.append(str(segment)+'\t'+'Upstream'+'\t'+txStr+'\t'+var+'\n')
                #print 'YES < 0'
            if segment > txLength:
                down=segment-txLength
                loc.append(str(down)+'\t'+'Downstream'+'\t'+txStr+'\t'+var+'\n')
                #print 'YES segment > txLength' 
        if txStr == "-":
            #print line_split
            readAv=readStart+(readStop - readStart)/2
            #print 'readAv', readAv
            segment=int(readAv-txStart)
            txLength=int(txStop-txStart)
            txLoc=(float(segment) / txLength) * 100
            newTxLoc=100-txLoc
            #print 'segment', segment
            #print 'txLength', txLength
            #print 'txLoc', txLoc
            #print 'newTxLoc', newTxLoc
            if segment >= 0 and txLength >= segment:
                loc.append(str(newTxLoc)+'\t'+'Body'+'\t'+txStr+'\t'+var+'\n')        
                #print 'YES in the body'
            if segment < 0:
                loc.append(str(segment)+'\t'+'Downstream'+'\t'+txStr+'\t'+var+'\n')
                #print 'YES < 0'
            if segment > txLength:
                down=segment-txLength
                loc.append(str(down)+'\t'+'Upstream'+'\t'+txStr+'\t'+var+'\n')
                #print 'YES segment > txLength' 


    f=open(outfile, 'w')
    for item in loc:
        f.write('%s' % item)
    f.close()

get_location()
