#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated file with transcript ids and intron coordinates. No stdin")
parser.add_option('-o', help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def intronChain():

    parsed={}
    joined={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        txID=line_split[0]
        intron=line_split[1].split('\n')[0]
    
        if txID not in parsed:
            parsed[txID]=[intron]
        else:
            parsed[txID].append(intron)


    for key in parsed:
        joined[key]='_'.join(parsed[key])
        #print key, '_'.join(parsed[key])
     
    f=open(outfile, 'w')
    for kyz in joined:
        f.write('%s\t' % kyz)
        f.write('%s\n' % joined[kyz])
    f.close()

intronChain()



