#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
        help="GTF/GTF. No stdin")
parser.add_option('-o', help='Output GTF file with intron edges')
parser.add_option('-r', help='Size of the genomic region')
options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
reg=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r reg " % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        reg=a
       
print ("Input file : %s \nOutput file: %s \nRegion: %s" % (infile,outfile,reg))


def split_introns():

    gtf={}
    edge=[]

    gtf_file=open(infile, 'r')
    for line in gtf_file:
        line_split=line.split("\n")[0].split("\t")
        typ=line_split[2]

        if typ == "intron":

                chrN=line_split[0]
                sth=line_split[1]
                typ=line_split[2]
                start=line_split[3]  
                stop=line_split[4]
                dot1=line_split[5]
                strand=line_split[6]
                dot2=line_split[7]
                cigar=line_split[8].split("\n")[0]
                geneID=line_split[8].split("\n")[0].split('"')[1]
                txID=line_split[8].split("\n")[0].split('"')[3]
                geneTp=line_split[8].split("\n")[0].split('"')[5]
                #print cigar                
                #print geneTp
                length=int(stop)-int(start)
                thr=2*int(reg)
                #print length
                #print thr
                if length > 2*int(reg):
                      
                    new_stop=str(int(start)+int(reg))
                    new_start=str(int(stop)-int(reg))

                    new_recordST=(chrN+"\t"+sth+"\t"+typ+"\t"+start+"\t"+new_stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+' "'+geneID+"_E1"+'"'+";"+" "+"transcript_id"+' "'+txID+"_E1"+'"'+";"+" "+"gene_type"+' "'+geneTp+'"'+";")           
                    new_recordSP=(chrN+"\t"+sth+"\t"+typ+"\t"+new_start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+' "'+geneID+"_E2"+'"'+";"+" "+"transcript_id"+' "'+txID+"_E2"+'"'+";"+" "+"gene_type"+' "'+geneTp+'"'+";")           
                    edge.append(new_recordST)  
                    edge.append(new_recordSP)

    f=open(outfile, "w")
    for k in edge:
        f.write('%s\n' % k)
    f.close() 

 
''' 
    f=open(outfile, "w")
    for k in edge:
        for v in edge[k]:
            f.write('%s\n' % v)
    f.close() 
'''
split_introns()
