#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated intropolis file. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-t', help='Threshold')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
thr=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:t:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-t':
        thr=a
print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def is_big(candidate):
    for n in candidate:
        if n > 2:
            return True
    return True

def getIntropolis():

    introns={}
    
    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split("\n")[0].split("\t")
        #print line_split
        chrN=line_split[0]
        start=line_split[1]
        stop=line_split[2]
        strand=line_split[3]
        ss1=line_split[4]
        ss2=line_split[5]
        samples=line_split[6]
        rsupport=line_split[7]
        intrCoord=chrN+"_"+start+"_"+stop+"_"+strand
        nsamples=len(samples.split(","))
        numbers = [ int(x) for x in rsupport.split(",")] 
        #n=sum(numbers)
        #print rsupport
        #print 'N', n
        if (nsamples >=int(thr)) and (sum(numbers) > len(samples.split(","))):
            introns[intrCoord]=line.split("\n")[0]
            #print intrCoord, introns[intrCoord]

    f=open(outfile, 'w')         
    for key in introns:
        f.write('%s\n' % introns[key])
    f.close()


getIntropolis()



