#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file containing gene_trans id and 1 or 2 rpkm values. No stdin")
parser.add_option('-o', help='output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:c:e:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a


print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def select():

    selected={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split(' ')
        #print 'line_spli', line_split
        #print 'len line_split', len(line_split)
        if line_split[2] != '\n':            
            gene_trans_id=line_split[0]
            rpkm1=float(line_split[1])
            rpkm2=float(line_split[2])
            df=str(rpkm1/rpkm2)

            selected[gene_trans_id]=df

    f=open(outfile, 'w')
    for key in selected:
        f.write('%s\t' % key)
        f.write('%s\n' % selected[key])
    f.close()

select()     

