#!/usr/bin/python
"""This script reads FASTA input line by line and splices it into k-mers, where k is defined by user"""
"""It is a part of a genome fragmentation pipeline and should come after sequence split and deletion of palindromes and exons, just before reverse complement"""


from optparse import OptionParser
from os import sys
import getopt
import re
import numpy as np


parser = OptionParser()
parser.add_option("-i", help="Id and seqence in tab-sepatated format")
parser.add_option("-k", help="Length of k-mers")
parser.add_option("-o", help="Output file in tab-separated format")

options, args = parser.parse_args()

sequenceinputfile=''
length=int()
outfile=''

myopts, args = getopt.getopt(sys.argv[1:],"i:k:o:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for opt, arg in myopts:
    if opt == '-i':
        sequenceinputfile=arg
    if opt == '-k':
        length=int(arg)
    if opt == '-o':
        outfile=arg

print ("Input file : %s \nOutput file: %s  \nk-mer length: %s" % (sequenceinputfile,outfile,length))

# body function
def GetKmers():

    kmers={}
    records=open(sequenceinputfile, 'r')
    for line in records:
        ID=line.strip('\n').split('\t')[0]
        sequence=line.strip('\n').split('\t')[1]
        #print "ID", line.strip('\n').split('\t')[0]
        #print "SEQ", sequence

        seg=np.arange(0, len(sequence), int(length))
        for i in seg:
            j=i+int(length)
            seqslice=sequence[i:j]
            if len(seqslice) == length:
                if ID not in kmers:
                    kmers[ID]=[seqslice]    
                else:
                    kmers[ID].append(seqslice)

    f=open(outfile, 'w')
    for key in kmers:
        kmerstr='\t'.join(map(str, kmers[key]))
        f.write('%s\t' % key)
        f.write('%s\n' % kmerstr)
    f.close()     

GetKmers()
