#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bedCoverage output. No stdin")
parser.add_option('-o', help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    
print ("Input file : %s \nOutput file: %s" % (infile,outfile))


def merge():

    trans_cigar={}
    trans_length={}
    trans_gene={}
    merged={} 
    sep=","

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split[3]
        trans_id=line_split[3].split('@')[0]
        gene_id=line_split[3].split('@')[1]
        length=line_split[4]
        cigar=line_split[5].split('\n')[0]

        # trans_gene

        trans_gene[trans_id]=gene_id

        # trans_length

        if trans_id not in trans_length:
            trans_length[trans_id]=[float(length)+1]
        else:
            trans_length[trans_id].append(float(length)+1)

        # trans_cigar

        if trans_id not in trans_cigar:
            trans_cigar[trans_id]=[cigar]
        else:
            trans_cigar[trans_id].append(cigar)

        
    for key in trans_gene:
       
        merged_length=sum(trans_length[key])
        merged_cigar=sep.join(trans_cigar[key])
        #check=len(merged_cigar.split(','))
        merged[key]=(key, trans_gene[key], str(merged_length), str(merged_cigar))   

    f=open(outfile, 'w')
    for keys in merged:
        for value in merged[keys]:
            f.write('%s\t' % value)
        f.write('\n')  
    f.close()

merge()

