#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bedCoverage output. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-l', help='Field containing length of the exon')
parser.add_option('-r', help='Reference transcript ids')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
fract=''
ref=''
take=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:l:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        take=a
        use=int(take)-1
    if o == '-r':
        ref=a 
    

print ("Input file : %s \nOutput file: %s \nReference ids %s" % (infile,outfile, ref))

def merge():

    trans_read={}
    trans_length={}
    trans_fraction={}
    trans_coverage={}
    trans_gene={}
    reference=[]
    merged={} 

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        trans_id=line_split[4]
        gene_id=line_split[5]
        reads=line_split[6]
        coverage=line_split[7]
        length=line_split[use]

        if trans_id not in trans_read:
            trans_read[trans_id]=[float(reads)]
        else:
            trans_read[trans_id].append(float(reads)) 


        if trans_id not in trans_length:
            trans_length[trans_id]=[float(length)+1]
        else:
            trans_length[trans_id].append(float(length)+1)


        if trans_id not in trans_coverage:
            trans_coverage[trans_id]=[float(coverage)]
        else:
            trans_coverage[trans_id].append(float(coverage))

        trans_gene[trans_id]=gene_id

        
    ref_file=open(ref, 'r')
    for lines in ref_file:
        reference.append(lines.split('\n')[0])
    for key in trans_read:
        if key in reference:
            merged_reads=sum(trans_read[key])
            merged_length=sum(trans_length[key])
            merged_coverage=sum(trans_coverage[key])
            av_fraction=(merged_coverage/merged_length)

            merged[key]=(key, trans_gene[key], str(merged_reads), str(merged_coverage), str(merged_length), str(av_fraction))

    f=open(outfile, 'w')
    for keys in merged:
        for value in merged[keys]:
            f.write('%s\t' % value)
        f.write('\n')  
    f.close()

merge()


