#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bed file with geneID@transID, counts as 5th and 6th column respectively. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-l', help='Field containing length of the exon')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''
take=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a 
    if o == '-l':
        take=a
        use=int(take)-1
    

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def merge():

    trans_read={}
    trans_length={}
    trans_gene={}
    reference=[]
    merged={} 

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print 'LS', line_split
        trans_id=line_split[4].split('@')[1]
        gene_id=line_split[4].split('@')[0]
        reads=line_split[5]
        length=line_split[use]
        #print 'LN', length

        if trans_id not in trans_read:
            trans_read[trans_id]=[float(reads)]
        else:
            trans_read[trans_id].append(float(reads)) 

        if trans_id not in trans_length:
            trans_length[trans_id]=[float(length)+1]
        else:
            trans_length[trans_id].append(float(length)+1)
   
        trans_gene[trans_id]=gene_id+"_"+trans_id
         
    for key in trans_read:
        merged_reads=sum(trans_read[key])
        merged_length=sum(trans_length[key])

        merged[key]=(key, str(merged_length), str(merged_reads))

    f=open(outfile, 'w')
    for keys in merged:
        for value in merged[keys]:
            f.write('%s\t' % value)
        f.write('\n')  
    f.close()
 
merge()
