#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated file with ID and values to be merged. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-r', help='Tab spearated file with values to be merged and addional column to form the table. No stdin')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref=a

print ("Input file : %s \nOutput file: %s\n ToMerge file: %s" % (infile,outfile,ref))

def maketable():

    ID_item={}
    item_elem={}
    merge={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split("\n")[0].split("\t")
        ID=line_split[0]
        item=line_split[1]
  
        if ID not in ID_item:
            ID_item[ID]=[item]
        else:
            ID_item[ID].append(item)

    ref_file=open(ref, 'r')
    for record in ref_file:
        record_split=record.split("\n")[0].split("\t")
        itemR=record_split[0]
        elem=record_split[1]

        item_elem[itemR]=elem
       

    for key in ID_item:
        for value in ID_item[key]:
            if value in item_elem:
                m=value+"\t"+item_elem[value]

                if key not in merge:
                    merge[key]=[m]
                else:
                    merge[key].append(m)
 
    f=open(outfile, 'w')         
    for kyz in merge:
        for value in merge[kyz]:
            f.write('%s\t' % kyz)
            f.write('%s\n' % value)
    f.close()

maketable() 
