#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated file with IDs to be merged by given separator. No stdin")
parser.add_option("-c", help="Column number with identifier to be merged. Identifiers do not have to be unique")
parser.add_option('-o', help='Output file')
#parser.add_option('-o', help='Separator')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
c_fld=''
#sep=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:c:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-c':
        c_fld=a
        c_use=int(c_fld)-1
    #if o == '-s':
    #   sep=a

#print ("Input file : %s \nOutput file: %s\n Separator: %s" % (infile,outfile,sep))
print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def merger():

    parsed={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split
        ids=line_split[0]
        elem=line_split[c_use].split('\n')[0]

        if ids not in parsed:
            parsed[ids]=[elem]
        else:
            parsed[ids].append(elem)

    f=open(outfile, 'w')
    for key in parsed:
        merged=','.join(parsed[key])
        f.write('%s\t' % key)
        f.write('%s\n' % merged)
    f.close()

merger()
