#!/usr/bin/python

__author__="BU"


"""This script creates metafile containing in each row exon_coord and RPKM or EIR values. If value is not present for given exon in given sample, NA values are introduced."""

# Usage python metafile.expression.ir.ECR.EWR.py -i input.gtf -o sjfile.txt -m ECR (or EWR)

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''
mode=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:m:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-m':
        mode=a

print ("Input file : %s \nOutput file: %s \nMODE: %s" % (infile,outfile,mode) )

# Body of GET_SJ function

def get_metafile(gff_file):
     
    coord_line={}
   
    gff=open(gff_file, 'r')
    for line in gff:
        line_split=line.strip().split(' ')
        #print 'L_SPLIT', '\n', line_split
        coord=line_split[0]
        #print 'COORD', '\n', coord
        ir=line_split[1]
        #print 'IR', '\n', ir
        #reads=line_split[2]
        coord_line[coord]=ir
    
    return coord_line
    

def get_list(row_id_file):
    list_row_id=[]

    row_id=open(row_id_file, 'r')
    for l in row_id:
        l_split=l.strip().split('\n')
        #print 'L_SPLIT', '\n', l_split[0]
        list_row_id.append(l_split[0])
    return list_row_id       


meta_dict={}

list_of_files=open(infile, 'r')
for filename in list_of_files:
    #print 'FILENAME', '\n', filename
    f=filename.split('\n')[0]
    #print 'F', '\n', f
    file_dict=get_metafile(f)
    if mode== 'ECR':
        list_coord=get_list('/users/rg/buszczynska/line_repeats/repeat-containing-exons/ECR.ensembl.ids.7152.txt')
    if mode == 'EWR':
        list_coord=get_list('/users/rg/buszczynska/line_repeats/repeat-containing-exons/coord.all.43357.EWR.txt')

    for elem in list_coord:
        if elem in file_dict:
            if elem not in meta_dict:
                meta_dict[elem]=[file_dict[elem]]
            else:
                meta_dict[elem].append(file_dict[elem])
        else:
            if elem not in meta_dict:
                meta_dict[elem]=['NA']
            else:
                meta_dict[elem].append('NA')

        #print 'META DICT', '\n', elem,  meta_dict[elem]
        #print 'META DICT ELEM 0', meta_dict[elem][0]
        #print 'META DICT ELEM 0', meta_dict[elem][0][0] 


f = open(outfile, 'w')
for key in meta_dict:
    f.write('%s\t' % key)
    for value in meta_dict[key]:
        f.write('%s\t' % value)
    f.write('\n')      
f.close()

