#!/usr/bin/python
"""This script checks if k-mers in input file are palindroms and, if they are, removes them from line"""

from optparse import OptionParser
from os import sys
import getopt
import re


parser = OptionParser()
parser.add_option("-i", help="Input containing ID and k-mers, output from kmers.py")
parser.add_option("-o", help="Output file, the same as input, except palindromic kmers")
options, args = parser.parse_args()

sequenceinputfile=''
outfile=''
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for opt, arg in myopts:
    if opt == '-i':
        sequenceinputfile=arg
    if opt == '-o':
        outfile=arg

# Load the input file
records=open(sequenceinputfile, 'r')
for line in records:
    record = filter(None, line.strip('\n').split('\t'))
    ID=record[0]
    nonpalindromes=''
    for kmer in record[1:]:
        N_count = kmer.count('N')
        if(kmer != kmer[::-1]) and N_count < 0.5*len(kmer):
            nonpalindromes += kmer+'\t'
    newline=ID+'\t'+nonpalindromes
    if nonpalindromes == '':
        newline = ID
    with open(outfile, 'a+') as out:
        out.write('%s\n' % newline)


