#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The tab-separated output of comptr with read id, class and tx list in each column. No stdin")
parser.add_option('-o', help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def parseComptr():
 
    catTX={}

    comptr=open(infile, 'r')
    for line in comptr:
        split=line.split('\n')[0].split('\t')
        #print split
        categ=split[1]
        transList=split[2].split('\n')[0].split(',')
        #print categ, transList

        if categ != "Monoexonic" and categ != "Intergenic_or_antisense":
            for trans in transList:
                if trans != '':
                    transID=trans.split('"')[1]
                    #print categ, transID
            
                if categ not in catTX:

                    catTX[categ]=[transID]
                else:
                    catTX[categ].append(transID)       

    f=open(outfile, 'w')
    for key in catTX:
        for item in catTX[key]:
            f.write('%s\t' % item)
            f.write('%s\n' % key)
    f.close()
     
parseComptr() 
