#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is overlap output in gff file and read id in 16th column. No stdin")
parser.add_option('-o', help='Output file with tx read count')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def parseOverlap():

    tx_read={} 
    tx_0={}
    merged={}
    readID=[]

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split(' ')
        #print 'LS', line_split
        txID=line_split[2].split('"')[1]
        #print 'txID', txID
        read=line_split[8].split('\n')[0]

        if read != ".": 
            readID_set=line_split[8].split('\n')[0].split(',')               
            #print 'READID_set', readID_set
            for readID in readID_set: 
                if txID not in tx_read:
                    tx_read[txID]=[readID]
                else:
                    tx_read[txID].append(readID) 

        if read == ".": 
            readID=read         
            if txID not in tx_0:
                tx_0[txID]=[readID]
            else:
                tx_0[txID].append(readID) 
            #print txID, tx_0[txID]

    for key in tx_read:
        merged[key]=(len(set(tx_read[key]))-1)
        #print 'MERGED', key, merged[key]
    for k in tx_0:
        if k not in tx_read:
            merged[k]=0

    f=open(outfile, 'w')
    for kz in merged:
        f.write('%s\t' % kz)
        f.write('%s\n' % merged[kz])  
    f.close()
       
parseOverlap()
