#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated file with IDs separated by semicolons. No stdin")
parser.add_option("-c", help="Column number with identifier to be split. Identifiers do not have to be unique")
parser.add_option('-o', help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
c_fld=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:c:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-c':
        c_fld=a
        c_use=int(c_fld)-1

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def spliter():

    parsed={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split
        ident=line_split[c_use].split('\n')[0]
        #print ident
        splited=ident.split(';')
        #print splited
        for item in splited:
            if item not in parsed:
                parsed[item]=[line.split('\n')[0]]
            else:
                parsed[item].append(line.split('\n')[0])

    f=open(outfile, 'w')
    for key in parsed:
            for it in parsed[key]:
                f.write('%s\t' % key)
                f.write('%s\n' % it)
    f.close()
  
        
spliter()
