#!/usr/bin/python

__author__="BU"


"""This script parses output of bwtool extract bed in order to get normalized number of nucleotides falling into exon boundries as a measure of expression (number of nucleotides / exon length)."""

# Usage python metafile.expression.ir.ECR.EWR.py -i input.gtf -o sjfile.txt -m ECR (or EWR)

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''
mode=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:m:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    #if o == '-m':
    #    mode=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of parsing_bwtool

def parsing_bwtool():

    int_values=[]
    exon_length_values={}

    bwtool_out=open(infile, 'r')
    for line in bwtool_out:
        line_split=line.split('\t') 
        chrom=line_split[0]
        start=line_split[1]
        stop=line_split[2]
        strand=line_split[5]
        length= float(stop)-float(start)
        exon_id=line_split[3].split('_')[1].split('.')[0]
        trans_id=line_split[3].split('_')[0].split('.')[0]
        #print 'EXN ID', exon_id
        values=line_split[7].split('\n')[0]
        values_split=values.split(',')
        for elem in values_split:
            if elem != '':
                if elem == 'NA':
                   int_values.append(0.0)
                else:
                   int_values.append(float(elem))
        #print 'IV', int_values
        #print 'SUV', sum(int_values)
        #if exon_id not in exon_length_values:
        exon_length_values[exon_id]=[(chrom+"_"+start+"_"+stop+"_"+strand, trans_id, str(sum(int_values)), str(length), str(sum(int_values)/length))]
        #else:
        #    exon_length_values[exon_id].append((start+"_"+stop+"_"+strand, sum(int_values), length, sum(int_values)/length))
        #print 'DICT', exon_id, exon_length_values[exon_id]
        int_values=[]  

    f=open(outfile, 'w')
    for key in exon_length_values:
        f.write('%s\t' % key)
        for val in exon_length_values[key]:
            for el in val:
                f.write('%s\t' % el)       
            f.write('\n')

parsing_bwtool()

