import numpy as np
import matplotlib.pyplot as plt
import matplotlib
import os
import sys
"""komenda odpalajaca skrypt python plot.py localisation_microarray_filtred bacgroundfile
Do odpalenia wymagana jest biblioteka matplotlib, python 2.6. Testowane na systemach unix."""

def readvaluesmicro(file1, bg_v, flag):
    """Czyta wskazany plik z odpowiednia opcja i zwraca zarowno etykiety
    macierzy, jak i wartosci kolejnch sad oraz sad testowych"""
    result = []#tablica zwracanych resultatow
    labels = []#etykiety sond na macierzy
    value = []#wartosci kolejnych sond
    test =[]#wartosci testowych sond, w plikach ktore otrzymalismy jednej sondy
    for line in file1:
        lin = line.split(',')
        if line.startswith('Ale'):
            test.append(int(float(lin[1]) - bg_v))
        elif line.startswith('miR_223'):
            if flag == 'HSA':
                test.append((float(lin[1]) - bg_v))
            elif flag == 'RNO':
                test.append((float(lin[2]) - bg_v))
            elif flag == 'MMU':
                test.append((float(lin[3]) - bg_v))
        else:
            if flag == 'HSA':
                labels.append(lin[0] + 'HSA')
                value.append((float(lin[1]) - bg_v))
            elif flag == 'RNO':
                labels.append(lin[0] + 'RNO')
                value.append((float(lin[2]) - bg_v))
            elif flag == 'MMU':
                labels.append(lin[0] + 'MMU')
                value.append((float(lin[3]) - bg_v))
    result.append(labels)
    result.append(tuple(value))
    result.append(test)
    return result

def plotmicro (values1, values2, labels, ynam, v1_nam, v2_nam, test, bg, fname, option):
    """Pobiera odpowiednie wartosci i rysuje wykres. Po pierwsze przyjmuje tuple
    wartosci sond, pozniej tuple tla, tuple etykiet, nazwe osi y(str),
    tytul wykresu(str), nazwy wartosci(str), tuple testowych wartosci, wartosc tla
    (jak ma sie wiecej elementow w tupli test niz 1, to bg powinno ich miec tyle samo)"""
    width = 0.75 #szerokosc
    print bg
    print test
    plt.clf()
    fig = matplotlib.pyplot.gcf()
    fig.subplots_adjust(bottom=0.2)
    ax = fig.add_subplot(111)
    ind2 = np.arange(len(values1))#rezerwuje miejsce na pierwsze slupki
    ind3 = np.arange(len(values1)+2)
    p1 = plt.bar(ind2, values2, width, color='y')#deklaruje wartosci dla kazdego slupka
    p2 = plt.bar(ind2, values1, width, color='r',
             bottom=values2)#deklaruje wartosci sond, nad wartosciami tla
    p4 = plt.bar(len(values1), (bg), width, color='y')#deklaruje dodatkowe tlo
    p3 = plt.bar(len(values1) , (test[0]), width, color='green',
             bottom=bg)#rysuje nad tlem wartosc testu
    p5 = plt.bar(len(values1) + 1, (bg), width, color='y')#deklaruje dodatkowe tlo
    p6 = plt.bar(len(values1) + 1, (test[1]), width, color='green',
             bottom=bg)#rysuje nad tlem wartosc testu
    plt.ylabel(ynam)#wrzuca etykiete osi y
    plt.title(fname.split('.')[0] + "_" + option)#dodaje tytul
    plt.xticks(ind3 + width / 2., labels , rotation=90, size = '8')#wrzuca etykiety slupkow
    plt.yticks(np.arange(0,max(values1),500))#zadeklarowac trzeba przedzial wartosci na osi y
    plt.legend( (p1[0], p2[0], p3[0] ), (v2_nam, v1_nam, 'test'))#tworzy legende
    DPI = fig.get_dpi()#wymiar wykresu
    DefaultSize = fig.get_size_inches()
    fig.set_size_inches( (DefaultSize[0]*4, DefaultSize[1]*2) )# zwiekszenie wykresu
    plt.savefig(fname.split('.')[0] + "_" + option)#zapisanie wykresu
    plt.close()#zamkniecie plot, gdyz kazdy kolejny nie jest usuwany z pamieci.
                #Bez tego moze nastapic przepelnienie pamieci
    
    

def readBg():
    """Funkcja czyta wartosci tla i zwraca slownik nazwa_macierzy:wartoscBG """
    bgs = {}
    f = open(sys.argv[2], 'r')
    for line in f:
        if line[0] != "#":
            line = line.split()
            bgs[line[1]] = float(line[2])        
    f.close()
    return bgs


#--------------------------------------------------------------

if __name__ == '__main__':
    bgs = readBg()
    path = sys.argv[1]
    for fname in os.listdir(path):
        if fname.endswith('.gpr'):
            for option in ['HSA', 'RNO', 'MMU']:
                input = open(path+fname,'r')
                if fname in bgs: 
                    bg = bgs[fname]
                else:
                    bg = 0
                result = readvaluesmicro(input, bg, option)
                input.close()
                i = 0
                tab_bg = []
                labels = result[0]
                while i<len(result[1]):
                    tab_bg.append(bg)
                    i += 1
                labels.append('Alexa_5')
                labels.append('miR223')
                plotmicro(result[1], tuple(tab_bg), tuple(labels), 'Intensity', 'normal', 'background', result[2], bg, fname, option)
else:
    raw_input('Give file name and options')
