#!/usr/bin/python

__author__="BUR"


"""This script will help to select merged regions of fragmented genome"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re


# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is output of matrix_parallel_final_v2_noawk.py with column names)")
parser.add_option('-o', help='Subset of matrix with biotype of fragment in 1st column')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

# subtract

def slicer():
    "This function slices matrix of genome k-mers and decodes merged regions."
    records={}
    reduced_bios={}
    biotypes=[]

    matrix=open(infile, 'r')
    for line in matrix:
        if not line.lstrip().startswith('#'):
            record=line.split('\n')[0].split('\t')
            #print record[3].split(',')
            fragID=record[3]
            
            records[fragID]=line.split('\n')[0]

            #print fragID
            elem=fragID.split('__')[0].split(',')
            #print "ELEM", elem
            for l in elem:
                #print "L", l   
                #print 'SPLIT', l.split('=')[4]
                bio=l.split('=')[4]     
                biotypes.append(bio)
            bioUniq=list(set(biotypes))

            if len(bioUniq) == 1:

                reduced_bios[fragID]=bioUniq

            if len(bioUniq) > 1:
                #print 'HERE'
                #print fragID
                #print 'bioUniq', bioUniq 
                if "protein_coding" in bioUniq:
                    bioUniq=['protein_coding']
                    reduced_bios[fragID]=bioUniq
                    #print "NEW", bioUniq  
                if ("protein_coding" not in bioUniq) and ("pseudogene" in bioUniq):
                    #print fragID
                    #print 'bioUniq', bioUniq 
                    bioUniq=['pseudogene']
                    reduced_bios[fragID]=bioUniq
                    #print "TEST"   
                    #print 'bioUniq', bioUniq 
                    #print "NEW", bioUniq
                if ("pseudogene" not in bioUniq) and ("non_coding" in bioUniq):
                    #print "YEAH!" 
                    bioUniq=['non_coding']
                    reduced_bios[fragID]=bioUniq
            #print 'BIOTYPES', biotypes
            #print 'bioUniq', bioUniq
            biotypes=[] 
    

    f=open(outfile, "w")
    for key in reduced_bios:
        f.write('%s\t' % key)
        for v in reduced_bios[key]:
            f.write('%s\t' % v)
        f.write('%s\n' % records[key])
    f.close() 

slicer()

