#!/usr/bin/python

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="Tab spearated file with trans id and its spliced length. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option('-r', help='Tab spearated file with read id and its mapped length. No stdin')
parser.add_option('-b', help='Tab spearated file with read id and trans id to which it is mapped. No stdin')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
readtx=''
readlen=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:t:b:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        readlen=a
    if o == '-b':
        readtx=a


print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def maketable():

    transLen={}
    readIdLen={}
    transRead={}
    merged={}

    txlength=open(infile, 'r')
    for line in txlength:
        split=line.split('\t')
        tx=split[0]
        txLen=split[1].split('\n')[0]

        transLen[tx]=txLen
        #print tx, transLen[tx]
  
    readlenFile=open(readlen, 'r')
    for l in readlenFile:
        s=l.split('\t')
        readID=s[0]
        readLen=s[1].split('\n')[0]
        
        readIdLen[readID]=readLen
        #print readID, readIdLen[readID]

    readtxFile=open(readtx, 'r')
    for r in readtxFile:
        spl=r.split('\t') 
        trans=spl[0]     
        read=spl[1].split('\n')[0]       

        if trans not in transRead:
            transRead[trans]=[read]
        else:
            transRead[trans].append(read)
        #print trans, transRead[trans]

    for key in transRead:
        for item in transRead[key]:
            #print key, item
            if item in readIdLen:
                if key not in merged:
                    merged[key]=[(transLen[key], readIdLen[item])]
                else:
                    merged[key].append((transLen[key], readIdLen[item]))
            #    print key, merged[key]

    f=open(outfile, 'w')
    for k in merged:
        for v in merged[k]:
            f.write('%s\t' % k)
            for i in v:
                f.write('%s\t' % i)
            f.write('\n')
    f.close() 
 
maketable()


