#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is gtf file. No stdin")
parser.add_option('-o', help='Output gff file with all records on both strands and changed trans and gene names')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def reverse():

    gene_gff={}

    gtf=open(infile, 'r')
    for line in gtf:
        split=line.split('\t')
        chrN=split[0]
        add=split[1]
        typ=split[2]
        start=split[3]
        stop=split[4]
        dot1=split[5]
        strand=split[6]
        dot2=split[7]
        transID=split[8].split(' ')[1].split('"')[1]
        transREV=transID+"REV"
        geneID=split[8].split(' ')[3].split('"')[1]
        geneREV=geneID+"REV"

        if strand == "+":
            record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+transID+'"'"; "+"transcript_id"+" "+'"'+transID+'"'";")
            recordREV=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+"-"+"\t"+dot2+"\t"+"gene_id"+" "+'"'+geneREV+'"'"; "+"transcript_id"+" "+'"'+transREV+'"'";")

            if geneID not in gene_gff:
                gene_gff[geneID]=[record]
            else:
                gene_gff[geneID].append(record)

            if geneREV not in gene_gff:
                gene_gff[geneREV]=[recordREV]
            else:
                gene_gff[geneREV].append(recordREV)

        if strand == "-":    
            record=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+strand+"\t"+dot2+"\t"+"gene_id"+" "+'"'+transID+'"'"; "+"transcript_id"+" "+'"'+transID+'"'";")
            recordREV=(chrN+"\t"+add+"\t"+typ+"\t"+start+"\t"+stop+"\t"+dot1+"\t"+"+"+"\t"+dot2+"\t"+"gene_id"+" "+'"'+geneREV+'"'"; "+"transcript_id"+" "+'"'+transREV+'"'";")

            if geneID not in gene_gff:
                gene_gff[geneID]=[record]
            else:
                gene_gff[geneID].append(record)

            if geneREV not in gene_gff:
                gene_gff[geneREV]=[recordREV]
            else:
                gene_gff[geneREV].append(recordREV)
  
    f=open(outfile, "w")
    for key in gene_gff:
        for v in gene_gff[key]:
            f.write('%s\n' % v)
    f.close() 
            
reverse()         


