#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .gtf. No stdin")
parser.add_option("-c", help="Column number with identifier. Identifiers do not have to be unique (1 for gene, 4 for trans)")
parser.add_option('-o', help='Output file')
parser.add_option('-r',help='File containing reference identifiers, based on which selection would be performed.')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
ref_id=''
c_fld=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:c:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a
    if o == '-c':
        c_fld=a
        c_use=int(c_fld)-1

print ("Input file : %s \nOutput file: %s \nReference ids: %s" % (infile,outfile,ref_id))

# ------------------------------------------------
# Function block
# ------------------------------------------------

def get_what_you_need():

    current={}
    reference=[]
    selected={}
 
    input_file=open(infile, 'r')
    for line in input_file:
        if not line.startswith('#'):
            line_split=line.split(' ')
            #print line_split
            ident=line_split[c_use].split('"')[1]#.split('"')[1].split(".")[0]
            #print ident

            if ident not in current:
                current[ident]=[line.split('\n')[0]]
            else: 
                current[ident].append(line.split('\n')[0])

    ref_file=open(ref_id, 'r')
    for record in ref_file:
        reference.append(record.split('\n')[0])
        #print reference
 
    for key in current:
        #print key
        if key in reference:
            selected[key]=current[key]
            #print key, selected[key]

    f=open(outfile, 'w')
    for keys in selected:
        for item in selected[keys]:
            f.write('%s\n' % item)
    f.close()

get_what_you_need()  
