#!/usr/bin/python

__author__="BUR"


"""This script will help to select merged regions of fragmented genome"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re


# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is output of process.regions.pX.v2.py with column names)")
parser.add_option('-o', help='Subset of matrix with biotype of fragment in 1st column')
parser.add_option('-b', help='Decoded gene biotype of interests (Intergenic, protein_coding, pseudogene, lncRNA, non_coding)')
parser.add_option('-n', help='Number of different biotype types that were collapsed into decoded gene biotype (Piorities: protein_coding, pseudogene, non_coding, Intergenic (should not be overlapping anything)).')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
biotypes=''
nb=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:b:n:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-b':
        biotypes=a
    if o == '-n':
        nb=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

# subtract

def selector():
    "This function selects regions of interest."

    metadata={}
    records={}


    matrix=open(infile, 'r')
    for line in matrix:
        if line.lstrip().startswith('#'):

            header=line.split('\n')[0]

        if not line.lstrip().startswith('#'):
            
            record=line.split('\n')[0].split('\t')
            fragID=record[0]

            records[fragID]=line.split('\n')[0]

            #print "FRAGID", fragID
            dced_bio=fragID.split('__')[2]
            #print "DECED_bio", dced_bio
            merged_nb=fragID.split('__')[3]
            #print "MERGED_NB", merged_nb
 
            #metadata[dced_bio,merged_nb]=[fragID]
            try:
                x = metadata[dced_bio,merged_nb]
            except KeyError:
                metadata[dced_bio,merged_nb]=[fragID]
                #print "VALUES", metadata.values()
            #if fragID not in metadata.values():
                #print 'HERE'
            metadata[dced_bio,merged_nb].append(fragID)
  
            #print dced_bio, merged_nb, metadata[dced_bio,merged_nb], "\n" 


    f=open(outfile, "w")
    f.write('%s\n' % header)
    for value in list(set(metadata[biotypes,nb])):
        f.write('%s\n' % records[value])
    f.close()     


    #for key1,key2 in metadata:
    #    print key1, key2, list(set(metadata[key1,key2]))    

selector()
