#!/usr/bin/python

__author__="BU"


"""This script contains only one fucntion calles join_sj_str, which selects splice junction for each record from raw output of Andrea's pipeline and combines those splice junctions with corresponding strand"""

# Usage python get_sj.py -i input.gtf -o sjfile.txt

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of JOIN_SJ_STR function

def join_sj_str():

    sj_str={}

    raw_pipeline_output=open(infile)
    for line in raw_pipeline_output:
        #print 'LINE', '\n', line
        line_split=line.split('\t')
        #print 'LINE_SPLIT', '\n', line_split
        strand=line_split[6]
        cigar=line_split[8]
        cigar_split=cigar.split(';')
        #print 'CIGAR SPLIT', '\n', cigar_split
        for elem in cigar_split:
            if elem.startswith(' EJ_id'):
                sj=elem.split('"')[1]
                sj_str[sj]=sj+"_"+strand
                #print 'SJ_STR', '\n', sj, sj_str[sj]

    f=open(outfile, 'w') 
    for key in sj_str:
        f.write('%s\n' % sj_str[key])
    f.close()
 
join_sj_str()
