#!/usr/bin/python

__author__="BU"


"""This script contains only one fucntion calles join_sj_str, which selects splice junction for each record from raw output of Andrea's pipeline and combines those splice junctions with corresponding strand"""

# Usage python get_sj.py -i input.gtf -o sjfile.txt

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of JOIN_SJ_STR function

def join_sj_str():

    sj_str={}
    control_list=[]

    raw_pipeline_output=open(infile)
    for line in raw_pipeline_output:
        #print 'LINE', '\n', line
        line_split=line.split('\t')
        #print 'line_split', '\n', line_split
        control_list.append(line_split)
        #print 'LINES', '\n', len(control_list)
        for unit in line_split:
            #print unit
            if unit.startswith('+') or unit.startswith('-'):
                #print 'LINE_SPLIT', '\n', line_split
                #print 'LINE SPLIT 1', '\n', line_split[1]
                strand=unit
            if unit.startswith('transcript_type') or unit.startswith('transcript_id') or unit.startswith('gene_id') or unit.startswith('"ENSG'):    
                cigar=unit           
                if len(cigar.split(';')) !=1:     
                    cigar_split=cigar.split(';')    
                    #print 'CIGAR SPLIT', '\n', cigar_split

                    for elem in cigar_split:
                        #print 'ELEM', '\n',elem
                        if elem.startswith(' EJ_id') or elem.startswith(' sj_id'):
                            sj=elem.split('"')[1]
                            #print 'SJ', '\n', sj

                            #if sj not in sj_str:
                            sj_str[sj]=[sj+"_"+strand]
                            #else:
                            #    sj_str[sj].append(sj+"_"+strand)
                            print 'KEYS', len(sj_str.keys())
                            #print 'SJ_STR', '\n', sj, sj_str[sj]
                            #print 'DIFF', '\n', float(len(control_list))-float(len(sj_str.keys()))

    f=open(outfile, 'w') 
    for key in sj_str:
        #print 'sj_str[key]', '\n', sj_str[key]
        for z in sj_str[key]:
            f.write('%s\n' % z)
    f.close()

join_sj_str()
