__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file containing full names of all files that are going to be used for creating a metafile. No stdin")
parser.add_option('-d', help='file with list of duplicated ids. Corresponding transcript ids should be provided in columns space separated')
parser.add_option('-o', help='output file')
parser.add_option('-r',help='file containing reference identifiers for filtering process.')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref_id=''
dup=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:d:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a
    if o == '-d':
        dup=a

print ("Input file : %s \nOutput file: %s \nReference ids: %s \nDuplicated trans ids: %s" % (infile,outfile,ref_id, dup))

def filtering():

    elements={}
    ref_list=[]
    filtered={}
    dups={}
 
    dup_file=open(dup, 'r')
    for record in dup_file:
        record_split=record.split(" ")
        dup1=record_split[0]
        dup2=record_split[1].split("\n")[0]
        dups[dup2]=dup1

    
    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split
        gene_id=line_split[3]
        trans_id=line_split[0]
        if trans_id in dups:
            trans_id=dups[trans_id]
        rpkm_score=line_split[9]
   
        elements[gene_id+"_"+trans_id]=rpkm_score


    list_ids=open(ref_id, 'r')
    for lines in list_ids:
        ref_list.append(lines.split('\n')[0])


    for key in elements:
        if key in ref_list:
            filtered[key]=elements[key]

    f=open(outfile, 'w')
    for keys in filtered:
        f.write('%s\t' % keys)
        f.write('%s\n' % filtered[keys])
    f.close()

filtering()
                
    

