__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file containing full names of all files that are going to be used for creating a metafile. No stdin")
parser.add_option('-o', help='output file')
parser.add_option('-r',help='file containing reference identifiers for filtering process.')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref_id=''


# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a

print ("Input file : %s \nOutput file: %s \nReference ids: %s" % (infile,outfile,ref_id))

def filtering():

    elements={}
    ref_list=[]
    filtered={}

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print 'LINE_SPLIT', line_split
        gtf_cigar=line_split[8].split(';')
        #print gtf_cigar
        for element in gtf_cigar:
            if element.startswith('gene_id'):
                gene_id=element.split('"')[1]
            if element.startswith(' transcript_id'):
                trans_id=element.split('"')[1]
            if element.startswith(' RPKM'):  
                rpkm_score=element.split('"')[1]
                #print rpkm_score

                elements[gene_id+"_"+trans_id]=rpkm_score
                #print elements


    list_ids=open(ref_id, 'r')
    for lines in list_ids:
        ref_list.append(lines.split('\n')[0])


    for key in elements:
        if key in ref_list:
            filtered[key]=elements[key]

    f=open(outfile, 'w')
    for keys in filtered:
        f.write('%s\t' % keys)
        f.write('%s\n' % filtered[keys])
    f.close()

filtering()
                
    

