#!/usr/bin/python

__author__="BU"


"""This script selects fasta sequence of primer pairs (F and R primers selected for testing)"""

# Usage python selecting.primers.from.fa.files.py -i input.gtf -o sjfile.txt -m Gen_name (Gen19 or GenM2)

from os import sys
import getopt
from itertools import izip

# Store input and output file

infile=''
outfile=''
mode=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:m:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-m':
        mode=a

print ("Input file : %s \nOutput file: %s \nMODE: %s" % (infile,outfile,mode))

def select_fasta():

    id_seq={}
    primer_list=[]
    selected={}
 
    fasta_file=open(infile, 'r')
    for line in fasta_file:
        #print 'LINE', '\n', line
        if line.startswith('>'):
            primer_id=line.split('\n')[0].split('>')[1]
            #print 'PRIMER ID', '\n', primer_id
        else:
            seq=line.split('\n')[0]
            #print 'SEQ', '\n', seq 
            id_seq[primer_id]= seq 
            #print 'RES', '\n', id_seq[primer_id],  primer_id
    print len(id_seq.keys())

    if mode == 'GEN19':
        primer_pair_file=open('/users/rg/buszczynska/Projects/sj.validation.180314/gen19.gtex.encode/f.r.primer.ids.gen19.txt', 'r')
        for lines in primer_pair_file:
            #print 'LINES', '\n', lines
            sel_primer_id=lines.split('\n')[0]
            #print 'SEL_PRIMER_ID', '\n', sel_primer_id
            primer_list.append(sel_primer_id)
        print 'list len', '\n', len(primer_list)

    if mode == 'GENM2':
        primer_pair_file=open('/users/rg/buszczynska/Projects/sj.validation.180314/genM2.encode/f.r.primer.ids.genM2.txt', 'r')

        for lines in primer_pair_file:
            #print 'LINES', '\n', lines
            sel_primer_id=lines.split('\n')[0]
            #print 'SEL_PRIMER_ID', '\n', sel_primer_id
            primer_list.append(sel_primer_id)
        print 'list len', '\n', len(primer_list)
    

    for elem in primer_list:
        if elem in id_seq:
            selected[elem]=id_seq[elem]
            #print 'elem', elem, selected[elem]            
            print 'length keys', '\n', len(selected.keys())  


    #f=open('/users/rg/buszczynska/Projects/sj.validation.180314/gen19.gtex.encode/primer_ids_from_fasta.txt', 'w')
    #for key in id_seq:
    #    f.write('%s\n' % key)
    #f.close() 
 
    ffile=open(outfile, 'w')
    for key in selected:
        ffile.write('>%s\n' % key)
        ffile.write('%s\n' % selected[key])
    ffile.close()
  
select_fasta()






