#!/usr/bin/python

__author__="BU"


"""This script selects fasta sequence of primer pairs (F and R primers selected for testing)"""

# Usage python selecting.primers.from.fa.files.py -i input.gtf -o sjfile.txt -m Gen_name (Gen19 or GenM2)

import argparse
from os import sys
import getopt
from itertools import izip

parser = argparse.ArgumentParser()
parser.add_argument("-i",
	help="Primer fasta file (the output of RT-PCR-SEQ pipeline)")
parser.add_argument('-o', help='Output file containg selected primer sequences')
parser.add_argument('-f',help='List of forward and reverse primer ids')
args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
ref=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:f:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -f primer ids" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-f':
        primerIDs=a

print ("Input file : %s \nOutput file: %s \nPrimer ids: %s" % (infile,outfile,primerIDs))

def select_fasta():

    id_seq={}
    primer_list=[]
    selected={}
 
    fasta_file=open(infile, 'r')
    for line in fasta_file:
        #print 'LINE', '\n', line
        if line.startswith('>'):
            primer_id=line.split('\n')[0].split('>')[1]
            #print 'PRIMER ID', '\n', primer_id
        else:
            seq=line.split('\n')[0]
            #print 'SEQ', '\n', seq 
            id_seq[primer_id]= seq 
            #print 'RES', '\n', id_seq[primer_id],  primer_id
    print len(id_seq.keys())

    primer_pair_file=open(primerIDs, 'r')
    for lines in primer_pair_file:
        #print 'LINES', '\n', lines
        sel_primer_id=lines.split('\n')[0]
        #print 'SEL_PRIMER_ID', '\n', sel_primer_id
        primer_list.append(sel_primer_id)
    print 'list len', '\n', len(primer_list)

    for elem in primer_list:
        #print elem
        if elem in id_seq:
            #print 'hmm'
            selected[elem]=id_seq[elem]
            #print 'elem', elem, selected[elem]            
            print 'length keys', '\n', len(selected.keys())  


    #f=open('/users/rg/buszczynska/Projects/sj.validation.180314/gen19.gtex.encode/primer_ids_from_fasta.txt', 'w')
    #for key in id_seq:
    #    f.write('%s\n' % key)
    #f.close() 
 
    ffile=open(outfile, 'w')
    for key in selected:
        ffile.write('>%s\n' % key)
        ffile.write('%s\n' % selected[key])
    ffile.close()
  
select_fasta()






