#!/usr/bin/python

__author__="BU"


"""This script selects records from gtf with unique primer pairs for testing"""

# Usage python selecting.uniq.primer.pairs.gtf.py -i input.gtf -o output.gtf

from os import sys
import getopt
from itertools import izip

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def uniq_records():
    
    fr_record={}

    gtf=open(infile)
    for line in gtf:
        line_split=line.split('\t')
        #print 'LINE SPLIT', '\n', line_split
        for elem in line_split:
            #print 'ELEM', '\n', elem
            if elem.startswith('gene_id'):
                cigar=elem
                cigar_split=cigar.split(';')
                #print 'CIGAR SPLIT', '\n', cigar_split
                for param in cigar_split: 
                    #print 'PARAM', '\n', param
                    if param.startswith(' Primer_F_id'):
                        fprimer_id=param.split('"')[1]
                        #print 'FPRIMER', '\n', fprimer_id
                    if param.startswith(' Primer_R_id'):
                        rprimer_id=param.split('"')[1]
                        #print 'RPRIMER', '\n', rprimer_id
                        primer_pair=fprimer_id+"_"+rprimer_id
                        #print 'PRIMER PAIR','\n', primer_pair
                        if primer_pair not in fr_record: 
                            fr_record[primer_pair]=[line]
                        else:  
                            fr_record[primer_pair].append(line)
                            if len(fr_record[primer_pair]) > 1:
                                print fr_record[primer_pair]

    #f=open(outfile, 'w')
    #for key in fr_record:
    #    f.write('%s' % fr_record[key])
    #f.close()

uniq_records()


