#!/usr/bin/python

__author__="BU"

"""This script selects max. overlap length for each repeat-containing exon from Adam's list"""

# Usage python selecing.max.rep.overlap.py -i input.gtf -o sjfile.txt

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile) )

# Body of select_max_overlap function

def select_max_overlap():

    id_size={}
    id_overlap={}
    id_ratio={}

    exon_xls=open(infile, 'r')
    for line in exon_xls:
        line_split=line.split('\t')
        #print line_split
        if line_split[9].startswith('ENSE'):
            exon_id=line_split[9]
            #print 'EXON ID', '\n', exon_id
        if line_split[13].isdigit():
            exon_size=line_split[13]
            #print 'EXON_SIZE', '\n', exon_size
        if line_split[15].isdigit():
            rep_overlap=line_split[15]
            #print 'REP_OVERLAP', '\n', rep_overlap
        
            if exon_id not in id_size:
                id_size[exon_id]=[exon_size]
            else:
                id_size[exon_id].append(exon_size)

            if exon_id not in id_overlap:
                id_overlap[exon_id]=[rep_overlap]
            else:
                id_overlap[exon_id].append(rep_overlap)
        #print 'ID SIZE', '\n', exon_id, id_size[exon_id]
        #print 'ID OVERLAP', '\n', exon_id, id_overlap[exon_id]
        #print 'LENGTH KEYS OVERLAP', '\n', len(id_overlap.keys())
        #print 'LENGTH KEYS SIZE', '\n', len(id_size.keys())

    for key in id_overlap:
        #print key, '\n'
        #print 'ID OVERLAP KEY', '\n', id_overlap[key]
        max_remp=max(id_overlap[key])
        #print 'MAX REMP', '\n', max_remp
        #print 'EXON SIZE', '\n', id_size[key]
        id_ratio[key]=str(float(max_remp)/float(id_size[key][0]))
        #print 'ID RATIO', '\n', id_ratio[key]

    f=open(outfile, 'w')
    for keys in id_ratio:
        f.write('%s\t' % keys)
        f.write('%s\n' % id_ratio[keys])
    f.close()
 
select_max_overlap()

