#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file containing full names of all files that are going to be used for creating a metafile. No stdin")
parser.add_option('-r',help='file containing reference identifiers with desired order.')
parser.add_option('-o', help='output file')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref_id=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r reflist" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a


print ("Input file : %s \nOutput file: %s \nReference ids: %s" % (infile,outfile,ref_id))

def sorting():

    storage={}
    refer=[]
    sort=[]

    filemess=open(infile, 'r')
    for line in filemess:
        line_split=line.split(' ')
        ids=line_split[0]
        elem=line_split[3].split('\n')[0]

        storage[ids]=elem
        #print 'STORAGE', ids, storage[ids]


    reference=open(ref_id, 'r')
    for lines in reference:
        refer.append(lines.split('\n')[0])
        #print 'REFER', refer

    for ref in refer:
        if ref in storage:
            sort.append((ref,storage[ref]))
            
    
    f=open(outfile, 'w')
    for items in sort:
        for i in items:        
            f.write('%s\t'% i)
        f.write('\n')
    f.close()

sorting()
        
