#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file containing full names of all files that are going to be used for creating a metafile. No stdin")
parser.add_option('-r',help='file containing reference identifiers with desired order.')
parser.add_option('-o', help='output file')
parser.add_option('-s', help='spearator (space or tab)')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
ref_id=''
sep=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:s:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -r reflist" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-r':
        ref_id=a
    if o == '-s':
        sep=a

if sep == "space":
    use=" "
    #print 'SPACE', use
if sep == "tab":
    use='\t'               
    #print 'TAB', use
print ("Input file : %s \nOutput file: %s \nReference ids: %s" % (infile,outfile,ref_id))

def sorting():

    storage={}
    refer=[]
    sort={}

    filemess=open(infile, 'r')
    for line in filemess:
        line_split=line.split(use)
        #print line_split
        ids=line_split[0].split('\n')[0]
        #print ids
        elem=line.split('\n')[0]

        storage[ids]=elem
        #print 'STORAGE', ids, storage[ids]


    reference=open(ref_id, 'r')
    for lines in reference:
        refer.append(lines.split('\n')[0])
        #print 'REFER', refer

    for ref in refer:
        #print ref
        #print "I'm in"  
        if ref in storage:
            if ref not in sort: 
                sort[ref]=[storage[ref]]
            else:
                sort[ref].append(storage[ref])
        if ref not in storage:
            if ref not in sort:
                sort[ref]=['NA']
            else:
                sort[ref].append('NA')
        #print ref, sort[ref]
    
    f=open(outfile, 'w')
    for key in sort:
        for item in sort[key]:
            #f.write('%s\t'% key)
            f.write('%s\n' % item)            
    f.close()

sorting()
