import os

def split_transcripts(gtf, adams_exon_list):

    exons = {}
    counter = []

    only_transcripts_gtf = open (gtf, 'r')
    for line in only_transcripts_gtf:
        line_split = line.strip().split('\t')
        record_type = line_split[2]
        if record_type.startswith('exon'):
            element_set = line_split[8].strip().split(";")
            for element in element_set:
                if element.strip().split(" ")[0].startswith('exon_id'):
                    #print 'ELEMENT 0' , '\n',element.strip().split(" ")[0]
                    exon_id_temp = element.strip().split(" ")[1]
                    exon_id = exon_id_temp[1:exon_id_temp.find(".")]
                    #print 'EXON ID', '\n',exon_id  
                    exons[exon_id]=line
                    counter.append(exon_id)
                    #print 'PROCESSING', len(counter), 'LINE OF FILE', '\n'
                    

    ensmbl_ids_repeats = [] 
 
    exons_with_repeats = {}
    hm_repeats = []

    exons_without_repeats ={}
    hm_without_repeats = []

    exon_ids_file = open(adams_exon_list, 'r')
    for lines in exon_ids_file:
        #print 'LINES','\n',lines
        lines_split = lines.split()
        seeked_exon_id = lines_split[0]
        ensmbl_ids_repeats.append(seeked_exon_id)
        #print 'SEEKED EXON ID', '\n', seeked_exond_id
            
    
    for key in exons.keys():
        #print 'KEY','\n', exons.keys()
        if key in ensmbl_ids_repeats:
            exons_with_repeats[key] = exons[key] 
            hm_repeats.append(key)
            #print 'EXON WITH REPEATS', '\n', len(hm_repeats)
        else:
            exons_without_repeats[key] = exons[key]
            hm_without_repeats.append(key)
            #print 'NO REPEATS', '\n', len(hm_without_repeats)    

    f = open("records_exons_WITH_repeats_FROM_TRANSCRIPTS_GTF_FILE"+".gtf", 'w')
    for k in exons_with_repeats.keys():
        f.write("%s" %  exons_with_repeats[k])
    f.close()

    fle = open("records_exons_WITHOUT_repeats_FROM_TRANSCRIPTS_GTF_FILE"+".gtf", 'w')
    for ki in exons_without_repeats.keys():
        fle.write("%s" % exons_without_repeats[ki])
    fle.close()

##############################################################
if __name__ == '__main__': 
    file_list = []   
    for files in os.listdir('.'): 
        if files.startswith('transcripts_with_repeated_elements_from_GEN_18_GTF_FILE.gtf') or files.startswith('unique_exon_ids_with_repeats_new_xls_file.txt'):
            file_list.append(files)
            file_list.sort()
            split_transcripts(file_list[0], file_list[1])   

    

 
