#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .txt file with dominant transcripts, where some transcript ids look like this TRANS1_TRANS2 due to the presence of duplicates in annotation (the same transcript different ids). No stdin")
parser.add_option('-o', help='output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s " % (infile,outfile))

def split_trans_id():

    splited={}

    dt_out=open(infile, 'r')
    for line in dt_out:
        line_split=line.split('\t')
        
        if len(line_split) == 4:
            gene_id=line_split[0]
            rpkm1=line_split[2] 
            list_trans_id=line_split[1].split('_')
            for trans_id in list_trans_id:                 
                splited[trans_id]=(gene_id, rpkm1) 
                     
        if len(line_split) == 5:
                       
            gene_id=line_split[0]
            rpkm1=line_split[2]      
            rpkm2=line_split[3]
            list_trans_id=line_split[1].split('_')
            for trans_id in list_trans_id: 
                splited[trans_id]=(gene_id, rpkm1, rpkm2)
   

    f=open(outfile, 'w')
    for key in splited:
        f.write('%s\t' % key)
        for items in splited[key]:
            f.write('%s\t' % items)
        f.write('\n')
    f.close()  
        
split_trans_id()
            


