#!/usr/bin/python

__author__="BU"


"""This script selects switches for dominant transcripts."""

# Usage python dominant.transcript.analysis.py -i switches.tsv -o output.txt 

from os import sys
import getopt
import heapq
from optparse import OptionParser

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="The input format is tab-delimited file containing sample1, sample2 and gene_trans id that has been determined as switch among those two samples")
parser.add_option("-o",  help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file: %s \nOutput file: %s" % (infile,outfile))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------

def switch():

    base={}
    filtered={}

    switches=open(infile, 'r')
    for line in switches:
        split=line.split('\t')
        sample1=split[0]
        sample2=split[1]
        gene=split[2].split("_")[0]
        trans=split[2].split("_")[1].split('\n')[0]
        #print sample1, sample2, gene, trans

        base[sample1,sample2,gene]=trans
        #print sample1,sample2,gene, base[sample1,sample2,gene]

    for s1, s2, geneID in base:
        if (s2, s1, geneID) not in filtered:
            if (s2,s1,geneID) in base:
                filtered[s1,s2,geneID]=[base[s1,s2,geneID], base[s2,s1,geneID]]
            if (s2,s1,geneID) not in base:
                filtered[s1,s2,geneID]=[base[s1,s2,geneID], "NOT_FOUND"]

    f=open(outfile, 'w')
    for key1, key2, key3 in filtered:
        f.write('%s\t' % key1)
        f.write('%s\t' % key2)
        f.write('%s\t' % key3)
        f.write('%s\t' % filtered[key1,key2,key3][0])
        f.write('%s\n' % filtered[key1,key2,key3][1])
    f.close()
         
switch()   
   
