#!/usr/bin/python

__author__="BU"


"""This script selects dominant transcripts for a given gene based on its expression threshold and threshold of fold change between dominant transcript and next highly expressed transcript."""

# Usage python dominant.transcript.analysis.py -i FLUXoutput.gtf -o output.txt -rpkm N -FC 

from os import sys
import getopt
import heapq
from optparse import OptionParser
import time

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="File you want to test")
#parser.add_option("-o",  help='Output file')


options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
#    if o == '-o':
#        outfile=a

print ("Input file: %s" % (infile))

# ---------------------------------------------------------------------------
# DEFINING THE BODY OF THE FUNCTION
# ---------------------------------------------------------------------------

def wigfixReader():
   
    wigfix_hash={}
    count=[]

    wigfix_file=open(infile, 'r')
    for record in wigfix_file:
        if record.startswith('fixedStep'):
            chrW=record.split(' ')[1].split("=")[1]
            startW=int(record.split(' ')[2].split("=")[1])
            stepW=int(record.split(' ')[3].split("=")[1].split('\n')[0])  
            count=[]
        else:            
            score=record.split('\n')[0]
            pos=startW+len(count)
            count.append(pos)
              
            wigfix_hash[pos,chrW]=score 
        
    #return wigfix_hash

def wigfix_map():
   
    wigfix_hash={}
    count=[]
    newlist=[]

    wigfix_file=open(infile, 'r')
    #b=map(str.split.startswith('fixedStep'), wigfix_file)
    #b=map(lambda chrW, startW, stepW: chrW.split(' ')[1].split("=")[1], startW.split(' ')[2].split("=")[1], int(stepW.split(' ')[3].split("=")[1].split('\n')[0]), wigfix_file)
    b=map(str.split, wigfix_file)

start = time.clock()
#wigfixReader()
wigfix_map()
end = time.clock()
print "%.2gs" % (end-start)


