#!/usr/bin/python

__author__="BU"


"""This script for meri that investigates, whether sjs are supported by RNA-Seq"""

# Usage python get_sj.py -i input.gtf -o sjfile.txt

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''
reffile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:r:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o =='-r':
        reffile=a
 
print ("Input file : %s \nOutput file: %s \nRef file: %s" % (infile,outfile, reffile) )

# Body of meri function

def meri():
     
    trans_sj={}
    supp_sj_list=[]
    validated={}
    check=[]

    transcripts=open(infile, 'r')
    for line in transcripts:
        line_split=line.split('\t')
        trans_id=line_split[0]
        #print 'TRANS ID', '\n', trans_id
        sj=line_split[1]
        #print 'SJ', '\n', sj

        if trans_id not in trans_sj:
           trans_sj[trans_id]=[sj]
        else:
           trans_sj[trans_id].append(sj)
        

    gtex_encode=open(reffile, 'r')
    for lines in gtex_encode:
        supp_sj=lines.split('\n')[0]
        #print 'supp_sj', '\n', supp_sj
        supp_sj_list.append(supp_sj)

    for key in trans_sj:
        for value in trans_sj[key]:
            #print 'VALUE', '\n', value
            if value in supp_sj_list:
                print 'I am supported!!!'
                if key not in validated:
                    validated[key]=[value]
                else:
                    validated[key].append(value)
                print 'validated', '\n', key, validated[key]     
            else:
                print "I am not supported!"
                check.append("I am not supported!")
                print 'NB of NOT SUPP', '\n', len(check)
    for sj in validated:
        validated[sj].append(len(trans_sj[sj]))
        validated[sj].append(len(validated[sj])-1)
        
        if len(trans_sj[sj])==len(validated[sj])-2:
            validated[sj].append('VALIDATED')
            valid.append('VALIDATED')
            #print 'NB of validated', '\n', len(valid)
        else:
            validated[sj].append('NOT VALIDATED')
            not_valid.append('NOT VALIDATED')
            #print 'NB of not validated', '\n', len(not_valid)
        #print 'validated NB', '\n', sj, validated[sj]
        #print 'validated keys', '\n',len(validated.keys())

    f=open(outfile, 'w') 
    for keys in validated:
        f.write('%s\t' % keys)
        for values in validated[keys]:                    
            f.write('%s\t' % values)
        f.write('\n')
    f.close()

              
meri()
