#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bed6 or bed12 with transcript coord. No stdin")
parser.add_option('-o', help='Output is bed6 with tss coord')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def tss():

    tssList=[]

    if infile == 'stdin':
        inBED = sys.stdin
    else:
        inBED = open(infile, 'r')
        #inBED=open(infile, 'r')

    for line in inBED:
        line_split=line.split('\n')[0].split('\t')
        chrN=line_split[0]
        start=int(line_split[1])
        stop=int(line_split[2])
        name=line_split[3]
        strand=line_split[5]

        if strand == "+":

            newStop=start+1  
            record=chrN+"\t"+str(start)+"\t"+str(newStop)+"\t"+name+"\t"+"0"+"\t"+strand

        if strand == "-":

            newStart=stop-1  
            record=chrN+"\t"+str(newStart)+"\t"+str(stop)+"\t"+name+"\t"+"0"+"\t"+strand
   
        tssList.append(record)

    f=open(outfile, 'w')  
    for item in tssList:
        f.write('%s\n' % item)
    f.close()

tss()
