#!/usr/bin/python

__author__="BU"


#"""This script selects dominant transcripts for set of samples. It's just to unify the choice and create single list. The dominant transcrit is selected if it is present in at least 2 samples. If it is impossible to select a DT, an Appris principal isoform is selected."""

"""This script selects dominant transcripts for set of samples. It's just to unify the choice and create single list. The dominant transcrit is selected if it is present in at least 2 samples. If it is impossible to select a DT based on it's presence the last choice is selected."""

# Usage python dominant.transcript.analysis.py -i switches.tsv -o output.txt 

from os import sys
import getopt
import heapq
from optparse import OptionParser
from collections import Counter

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="The input format is a file containing gene_trans id for all samples")
parser.add_option("-o",  help='Output file')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file: %s \nOutput file: %s" % (infile,outfile))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------

def switch():

    base={}
    filtered={}

    dts=open(infile, 'r')
    for line in dts:
        #print line.split('\n')[0]
        splito=line.split('\n')[0]
        gene=splito.split("_")[0]
        trans=splito.split("_")[1]
        #print gene, trans

        if gene not in base:
            base[gene]=[trans]
        else:   
            base[gene].append(trans)

        #print gene, base[gene]

    for key in base:
        occurence_count = Counter(base[key]) 
        major = occurence_count.most_common(1)[0][0] 
        counter = occurence_count.most_common(1)[0][1]

        filtered[key]=major

        #if int(counter) > 1:
        #    filtered[key]=major

        #elif int(counter) == 1:  
                 
        #print key, occurence_count.most_common(1)[0][1]


    f=open(outfile, 'w')
    for kyz in filtered:
        f.write('%s_' % kyz)
        f.write('%s\n' % filtered[kyz])
    f.close()

switch()   
   
