#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# -------------------------------------------------------------
## OPTION PARSING
# -------------------------------------------------------------
parser = OptionParser()
parser.add_option("-i", 
	help="The input is p3primer.set.gtf file. No stdin")
parser.add_option('-o', help='Output file')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
mode=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def convert_old():

    converted=[]

    inputfile=open(infile, 'r')
    for line in inputfile:
        line_split=line.split('\t')
        #print line_split 
        chrom=line_split[0]
        havana=line_split[1]
        ej=line_split[2]
        start=line_split[3]
        stop=line_split[4]
        dot=line_split[5]
        strand=line_split[6]

        cigar=line_split[8].split(';')

        for elem in cigar:
            if elem.startswith('gene_id'):
               gene=elem
            if elem.startswith(' transcript_id'):
               trans=elem
            if elem.startswith(' gene_type'):
                gene_type=elem
            if elem.startswith(' gene_status'):
                gene_status=elem
            if elem.startswith(' gene_name'):
                gene_name=elem
            if elem.startswith(' transcript_type'):
                transcript_type=elem
            if elem.startswith(' transcript_status'):
                transcript_status=elem
            if elem.startswith(' transcript_name'):
                transcript_name=elem
            if elem.startswith(' exon_number'):
                exon_number=elem
            if elem.startswith(' exon_id'):
                exon_id=elem
            if elem.startswith(' level'):
                level=elem
            if elem.startswith(' tag'):
                tag=elem
            if elem.startswith(' transcript_support_level'):
                tsl=elem
            if elem.startswith(' havana_gene'):
                havana_gene=elem
            if elem.startswith(' havana_transcript'):
                havana_trans=elem
            if elem.startswith(' EJ_id'):
                sj=elem
                #sj=" sj_id"+" "+elem.split(' ')[2]
                #print sj
            if elem.startswith(' EJ_ex1'):
                ej_ex1=elem
                #start=elem.split(' ')[2].split(',')[0].split('"')[1]
            if elem.startswith(' EJ_ex2'):
                ej_ex2=elem
                #stop=elem.split(' ')[2].split(',')[1].split('"')[1] 
            if elem.startswith(' Primer_F_id'):
                primerF=elem
            if elem.startswith(' Primer_R_id'):
                primerR=elem
            if elem.startswith(' Primer_F_pos'):
                primerF_pos=elem
                Flow=int(primerF_pos.split('"')[1])+5
                Fup=int(primerF_pos.split('"')[3])+5
                #print primerF_pos
                newPrimerF_pos=' Primer_F_pos'+' "'+str(Flow)+'","'+str(Fup)+'"'
                #print "NEW", newPrimerF_pos 
            if elem.startswith(' Primer_R_pos'):
                primerR_pos=elem
                Rlow=int(primerR_pos.split('"')[1])+5
                Rup=int(primerR_pos.split('"')[3])+5
                newPrimerR_pos=' Primer_R_pos'+' "'+str(Rlow)+'","'+str(Rup)+'"'  
                #print primerR_pos
                #print "NEWR", newPrimerR_pos
            if elem.startswith(' Primer_F_gc'):
                primerF_gc=elem
            if elem.startswith(' Primer_R_gc'):
                primerR_gc=elem
            if elem.startswith(' Primer_F_tm'):                
                primerF_tm=elem
            if elem.startswith(' Primer_R_tm'):
                primerR_tm=elem
            if elem.startswith(' primerdesign'):
                design=elem
            if elem.startswith(' target_start'):
                target_start=' target_start'+' "'+str(Flow)+'"'
            if elem.startswith(' target_end'):
                target_end=' target_end'+' "'+str(Rup)+'"'
            if elem.startswith(' amplicon_size'):
                amplicon_size=elem
                
                converted.append(chrom+'\t'+havana+'\t'+ej+'\t'+start+'\t'+stop+'\t'+dot+'\t'+strand+'\t'+dot+'\t'+gene+';'+trans+';'+gene_type+';'+gene_status+';'+gene_name+';'+transcript_type+';'+transcript_status+';'+transcript_name+';'+exon_number+';'+exon_id+';'+level+';'+tag+';'+tsl+';'+havana_gene+';'+havana_trans+';'+sj+';'+ej_ex1+';'+ej_ex2+';'+primerF+';'+primerR+';'+newPrimerF_pos+';'+newPrimerR_pos+';'+primerF_gc+';'+primerR_gc+';'+primerF_tm+';'+primerR_tm+';'+design+';'+target_start+';'+target_end+';'+amplicon_size)

    f=open(outfile, 'w')
    for item in converted:
        f.write('%s\n' % item)
    f.close()

convert_old()


