#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-c", help="cufflinks fpkms")
parser.add_option('-f',help="flux fpkms")
parser.add_option('-o', help='output file')


options, args = parser.parse_args()


# Store input and output file

cuff=''
flux=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"c:f:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-c':
        cuff=a
    if o == '-f':
        flux=a
    if o == '-o':
        outfile=a

print ("Cufflinks file: %s \nFlux file: %s \nOutput file: %s" % (cuff,flux,outfile))

# =============
# Fuction comp
# =============

def comp():

    cuff_hash={}
    flux_hash={}
    problem={}  
  
    cuff_file=open(cuff, 'r')
    for line in cuff_file:
        line_split=line.split(' ')
        cuff_id=line_split[0]
        cuff_fpkm=line_split[1].split('\n')[0]
        cuff_hash[cuff_id]=cuff_fpkm
        #print "cuff", cuff_id, cuff_hash[cuff_id]

    flux_file=open(flux, 'r')
    for lines in flux_file:
        lines_split=lines.split(' ')
        flux_id=lines_split[0]
        flux_fpkm=lines_split[1].split('\n')[0]
        flux_hash[flux_id]=flux_fpkm
        #print "Flux", flux_id, flux_hash[flux_id]


    for key in cuff_hash:
        #print key
        if key in flux_hash:
            #print 'I am here'
            #print "cuff", cuff_hash[key]
            #print "flux", flux_hash[key]
            if not cuff_hash[key] == flux_hash[key] and flux_hash[key] != 'NA':
                #print 'Not Eq cuff', cuff_hash[key]
                #print 'Not Eq flux', flux_hash[key]
                if float(flux_hash[key]) > 0:
                    if float(cuff_hash[key])/float(flux_hash[key]) == 0 or  float(cuff_hash[key])/float(flux_hash[key]) >= 20 or float(cuff_hash[key])/float(flux_hash[key]) <= 0.05:
                        problem[key]=(flux_hash[key], cuff_hash[key])
                        #print 'problem', key, problem[key]
                if float(flux_hash[key]) == 0:
                        if float(flux_hash[key])/float(cuff_hash[key]) == 0:               
                            problem[key]=(flux_hash[key], cuff_hash[key])
                #print 'problem', key, problem[key] 

    header="ID"+"\t"+"Flux_fpkm"+"\t"+"Cuff_fpkm"
    f=open(outfile, 'w')
    f.write('%s\n' % header)
    for keys in problem:
        f.write('%s\t' % keys)
        for item in problem[keys]:
            f.write('%s\t' % item)
        f.write('\n')
    f.close() 
         
comp()
