#!/usr/bin/python

__author__="BU"


"""This script slices bed records into fragments of defined length"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re
import numpy
from collections import OrderedDict


# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bed format without str info")
parser.add_option('-o', help='Fragmented bed')
parser.add_option('-l', help='Length of fragments')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
length=''
strand=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        length=a

print ("Input file : %s \nOutput file: %s  \nLength: %s" % (infile,outfile,length))

# subtract
def split(word): 
    return [char for char in word] 


#seqSet={}
seqSet=[]

def slicer():

    "This function slices records in tsv file using defined fragment length"
    pieces=[]

    bed=open(infile, 'r')
    for line in bed:
        record=line.split('\n')[0].split('\t')
        chrN=record[0]
        seq=record[1]
        #ll=int(length)-1
        ll=int(length)
        slc=[seq[i:i+ll] for i in range(0, len(seq), ll)]
        j=0
        for frag in slc:
            z=j+len(frag)-1
            px=chrN+"="+str(j)+"="+str(z)+"+=S=faSplit__PX"
            #seqSet[px]=frag
            wr=px+"\t"+frag
            seqSet.append(wr)                
            j=j+len(frag)
        #print seqSet      
        
    f=open(outfile, 'w')
    for item in seqSet:
         f.write('%s\n' % item) 
        #f.write('%s\t' % item)
        #f.write('%s\n' % seqSet[item]) 
    f.close()     

slicer()

