#!/usr/bin/python

__author__="BU"


"""This script produces gene read counts from transcript read counts"""

# Usage python dominant.transcript.analysis.py -i FLUXoutput.gtf -o output.txt -rpkm N -FC 

from os import sys
import getopt
import heapq
from optparse import OptionParser

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i",  help="The input format is tab-delimited file containing transcript id and read counts for given transcript")
parser.add_option("-o",  help='Output file')
parser.add_option("-t", help="List of transcript and gene ids")

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
trans_gene=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:t:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-t':
        trans_gene=a

print ("Input file: %s \nOutput file: %s \nTrans-gene file: %s" % (infile,outfile,trans_gene))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------

def gene_red_counts():

    trans_counts={}
    trans_gene_ids={}
    gene_counts={}

    # Trans_counts

    trans_count_file=open(infile, 'r')
    for line in trans_count_file:
        line_split=line.split('\t')
        trans_id=line_split[0]
        counts=int(line_split[1].split('\n')[0])
        trans_counts[trans_id]=counts     
        #print trans_id, trans_counts[trans_id]
    
    # trans-gene_id

    trans_gene_file=open(trans_gene, 'r')
    for record in trans_gene_file:
        record_split=record.split('\t')
        gene_id=record_split[0]
        tx_id=record_split[1].split('\n')[0]
        
        if gene_id not in trans_gene_ids:
            trans_gene_ids[gene_id]=[tx_id]
        else:   
            trans_gene_ids[gene_id].append(tx_id)

    # Gene_counts        

    for key in trans_gene_ids:
        for value in trans_gene_ids[key]:
            if value in trans_counts:
                if key not in gene_counts:
                    gene_counts[key]=[trans_counts[value]]
                else: 
                    gene_counts[key].append(trans_counts[value])
        gene_counts[key]=sum(gene_counts[key])
        #print key, gene_counts[key]               

    f=open(outfile, 'w')
    for k in gene_counts:
        f.write('%s\t' % k)
        f.write('%s\n' % gene_counts[k])
    f.close()
    
gene_red_counts()      
