#!/usr/bin/python

__author__="BU"


"""This script slices genome sequence (in one line format) into fragments."""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re
import numpy
from collections import OrderedDict


# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is genome sequence in one line format")
parser.add_option('-o', help='Fragments of genome')
parser.add_option('-l', help='Length of fragments')
parser.add_option('-s', help='Strand')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''
length=''
strand=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:l:s:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-l':
        length=a
        take=int(a)+1
    if o == '-s':
        strand=a

print ("Input file : %s \nOutput file: %s  \nLength: %s \nStrand: %s" % (infile,outfile,length,strand))

# subtract

def slicer():

    "This function slices genome sequence (in one line format) into fragments of length defined by the user. It also prints out the coordinates (start, stop, strand) for each fragment."
    pieces={}

    genome=open(infile, 'r')
    for line in genome:
        sequence=line.split('\n')[0]
        seg=numpy.arange(0, len(sequence), int(length))
        #print seg
        #print "LENG", len(sequence)
        #print "length", length
        for i in seg:
            j=i+int(length)
            #print "I", i
            #print "J", j
            seqslice=sequence[i:j]
            #print len(seqslice)
            #print seqslice
            if len(seqslice) == length:
                coord="PX"+str(i+1)+"_"+str(j)+"_"+strand
                pieces[coord]=seqslice
            if len(seqslice) < length:
                coord="PX"+str(i+1)+"_"+str(i+len(seqslice))+"_"+strand
                pieces[coord]=seqslice
   
                  
    f=open(outfile, 'w')
    for key in pieces:
        f.write('%s\t' % key)
        f.write('%s\n' % pieces[key])
    f.close()     
  
   
slicer()

