#!/usr/bin/python

__author__="BU"


"""This script selects havana tx and gene id for transcripts."""

# Usage python dominant.transcript.analysis.py -i FLUXoutput.gtf -o output.txt -rpkm N -FC 

from os import sys
import getopt
import heapq
from optparse import OptionParser

# ----------------
## OPTION PARSING
# ----------------

parser = OptionParser()
parser.add_option("-i", help="The input format is gtf file. No stdin")
parser.add_option('-o', help='Output file with the list of havana tx and gene id')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

#if myopts == []:
#    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file: %s \nOutput file: %s" % (infile,outfile))

#-------------------------------------------------------------------------------------------------
# Defining Functions
#-------------------------------------------------------------------------------------------------
                   
def get_havana():

    """Get havana tx and gene ids for transcripts""" 
    havana={}

    input_file=open(infile, 'r')
    for lines in input_file:
        lines_split=lines.split('\t')
        if lines_split[2]=='transcript':
            gtf_cigar=lines_split[8].split(';')

            for unit in gtf_cigar:
                #print unit
        
                if unit.startswith(' havana_gene'):
                    gene=unit.split('"')[1].split('.')[0]
                    #print "gene", keygene
                if unit.startswith(' havana_transcript'):
                    trans=unit.split('"')[1].split('.')[0]
                    #print "trans", keytrans
            
                    havana[trans]=gene
                    #print trans, havana[trans]

    f=open(outfile, 'w')
    for key in havana:
        f.write('%s\t' % key) 
        f.write('%s\n' % havana[key]) 
    f.close()
     
get_havana()
