#!/usr/bin/python

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def merge_exons():
     
    gene_reads={}
    gene_exp={}
    check=[]

    bed=open(infile, 'r')
    for line in bed:
        #print line
        line_split=line.split('\t')
        check.append(line)
        #print line_split
        tmp_gi=line_split[3]
        nb_reads=line_split[6].split('\n')[0]
        #print tmp_gi
        #print 'NBR', '\t', nb_reads
        merged_gi=tmp_gi.split(';')
        #print 'MERGED',merged_gi
        #print len(merged_gi)
        if len(merged_gi) == 1:
            if merged_gi[0] not in gene_reads:
                gene_reads[merged_gi[0]]=[float(nb_reads)]
            else:
                gene_reads[merged_gi[0]].append(float(nb_reads)) 
        if len(merged_gi) > 1:
            for i in range(1,(len(merged_gi)+1)):
                j=i-1
                #print 'LEN', len(merged_gi)
                #print 'I', i
                #print 'J', j
                if merged_gi[j] not in gene_reads:
                    gene_reads[merged_gi[j]]=[float(nb_reads)]
                else:
                    gene_reads[merged_gi[j]].append(float(nb_reads))
            
            #print 'DICT', len(gene_reads.keys())
            #print 'CHECK', len(check)
        #if len(merged_gi) > 2:
        #    print 'CAUTION YOU ARE LOOSING SOMETHING!!!'

    for key in gene_reads:
        #print 'GENE AND READ', gene_reads[key]
        exp_per_gene=sum(gene_reads[key])
        gene_exp[key]=str(exp_per_gene)
        #print 'GENE AND SUM', key, gene_exp[key]
        #print len(gene_exp.keys())            

    f=open(outfile,'w')
    for k in gene_exp:
      f.write('%s\t' % k)
      f.write('%s\n' % gene_exp[k])
    f.close()  


merge_exons() 
