#!/usr/bin/python

from os import sys
import getopt

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def merge_exons():
     
    gene_reads={}
    gene_exp={}
    check=[]

    bed=open(infile, 'r')
    for line in bed:
        #print 'LINE', line
        line_split=line.split('\t')
        gene_id=line_split[0]
        fpkm=line_split[1].split('\n')[0]
        #print gene_id
        #print 'FPKM', fpkm
        
        if gene_id not in gene_reads:
            gene_reads[gene_id]=[float(fpkm)]
        else:
            gene_reads[gene_id].append(float(fpkm)) 
        #print 'GENE_READS', gene_id, gene_reads[gene_id]

    for key in gene_reads:
        #print 'GENE AND READ', gene_reads[key]
        exp_per_gene=sum(gene_reads[key])
        gene_exp[key]=str(exp_per_gene)
        #print 'GENE AND SUM', key, gene_exp[key]
        #print len(gene_exp.keys())            

    f=open(outfile,'w')
    for k in gene_exp:
      f.write('%s\t' % k)
      f.write('%s\n' % gene_exp[k])
    f.close()  


merge_exons() 
