#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is bedtools intersect output with wa and wb, bed6. No stdin")
parser.add_option('-o', help='Output file with list of merged domains')
parser.add_option('-g', help='Output GTF with merged uniprot domains')



options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
outgtf=''
# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:g:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -g outgtf" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-g':
        outgtf=a
        
print ("Input file : %s \nOutput file: %s \nOutputGTF: %s" % (infile,outfile,outgtf))

def mergeUniprot():

    bedfile=open(infile, 'r')

    gtfToUniprot={}
    start=[]
    stop=[]
    merge={}
    mergeGtf={}

    for line in bedfile:

        line_split=line.split("\n")[0].split('\t')
        chr_gtf=line_split[0]
        start_gtf=line_split[1]
        stop_gtf=line_split[2]
        tx_gtf=line_split[3]
        str_gtf=line_split[5]
        coord_gtf=chr_gtf+"_"+start_gtf+"_"+stop_gtf+"_"+str_gtf

        chr_uniprot=line_split[6]
        start_uniprot=line_split[7]
        stop_uniprot=line_split[8]
        tx_uniprot=line_split[9]+":"+line_split[10]
        str_uniprot=line_split[11]       
        coord_uniprot=chr_uniprot+"_"+start_uniprot+"_"+stop_uniprot+"_"+str_uniprot
 
        if (coord_gtf,tx_uniprot) not in gtfToUniprot: 
            gtfToUniprot[coord_gtf,tx_uniprot]=[coord_uniprot]
        else:
            gtfToUniprot[coord_gtf,tx_uniprot].append(coord_uniprot) 

        #print coord_gtf, tx_uniprot, gtfToUniprot[coord_gtf,tx_uniprot]

    for CE_exon,txID in gtfToUniprot:                  
        for item in set(gtfToUniprot[CE_exon,txID]):
            start_tmp=int(item.split("_")[1])
            stop_tmp=int(item.split("_")[2])
            chrom=item.split("_")[0]
            strand=item.split("_")[3]
            start.append(start_tmp)
            stop.append(stop_tmp)
        start.sort()
        stop.sort()  
        start_merged=start[0]
        stop_merged=stop[len(stop)-1]
        
        # merged exons
        coord_merged=chrom+"_"+str(start_merged)+"_"+str(stop_merged)+"_"+strand

        merge[CE_exon,txID]=[coord_merged] 
        #print CE_exon, txID, merge[CE_exon,txID]
        
        # gtf for domains with merged exons
        tx_merged=txID.split(':')[0]
        domain=txID.split(':')[1]
       
        record=(chrom+"\t"+domain+"\t"+"exon"+"\t"+str(start_merged)+"\t"+str(stop_merged)+"\t"+"."+"\t"+strand+"\t"+"."+"\t"+"gene_id"+" "+'"'+tx_merged+'"'"; "+"transcript_id"+" "+'"'+txID+'"'";")

        if txID not in mergeGtf:
            mergeGtf[txID]=[record]
        else:
            mergeGtf[txID].append(record)

        start=[]
        stop=[]


    f=open(outfile, 'w')
    for key1, key2 in merge:
        f.write('%s\n' % merge[key1,key2][0])
    f.close   
              
    gtf=open(outgtf, 'w')
    for key in mergeGtf:
        for item in mergeGtf[key]:
            gtf.write('%s\n' % item)
    gtf.close() 
                
mergeUniprot()


