#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is overlap output in gff file and read id in 16th column. No stdin")
parser.add_option('-o', help='Output file with gene read count')

options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def parseOverlap():

    gene_read={} 
    gene_0={}
    merged={}
    readID=[]

    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split(' ')
        #print 'LS', line_split
        geneID=line_split[2].split('"')[1]    
        #print 'geneID', geneID

        read=line_split[8].split('\n')[0]
        #print 'READ', read

        if read != ".": 
            readID_set=line_split[8].split('\n')[0].split(',')               
            #print 'READID_set', readID_set
            for readID in readID_set: 
                if geneID not in gene_read:
                    gene_read[geneID]=[readID]
                else:
                    gene_read[geneID].append(readID) 

        if read == ".": 
            readID=read         
            if geneID not in gene_0:
                gene_0[geneID]=[readID]
            else:
                gene_0[geneID].append(readID) 
            #print geneID, gene_0[geneID]

    for key in gene_read:
        merged[key]=(len(set(gene_read[key]))-1)
        #print 'MERGED', key, merged[key]
    for k in gene_0:
        if k not in gene_read:
            merged[k]=0

    f=open(outfile, 'w')
    for kz in merged:
        f.write('%s\t' % kz)
        f.write('%s\n' % merged[kz])  
    f.close()
      
parseOverlap()
