#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .db file containing GeneBank records. No stdin")
parser.add_option('-o', help='Output file, containing transcript, gene id and the definition (function)')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def parse():

    name=[]
    gene_info={}

    db_file=open(infile, 'r')

    for line in db_file:
        #print line
        if line.startswith('LOCUS'):
            locus_cigar=line.split(' ')
            for elem in locus_cigar:
                if elem.startswith('XM') or elem.startswith('NW'):
                    trans_id=elem   
                    #print trans_id
        if line.startswith('DEFINITION'):
            definition_cigar=line.split(' ')
            for item in definition_cigar:
                #print definition_cigar
                if item == "DEFINITION" or item == "" or item == 'PREDICTED:':
                    pass
                else:  
                    #print "item", item  
                    name.append(item.split('\n')[0])                
            function='_'.join(name).split(',')[0]                     
            #print function
            name=[]
        if line.startswith('                     /db_xref="GeneID:'):
            gene_split=line.split(' ')
            for g in gene_split:
                if g.startswith('/db_xref'):     
                    gene_id=g.split(':')[1].split('"')[0].split('\n')[0]
                    #print 'GENE ID', gene_id

                    gene_info[trans_id]=(gene_id, function) 

    f=open(outfile, 'w')
    for key in gene_info:
        f.write('%s\t' % key)
        for value in gene_info[key]:                       
             f.write('%s\t' % value)  
        f.write('\n')
    f.close()

parse()     

