#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", 
	help="The input format is .db file containing GeneBank records. No stdin")
parser.add_option('-o', help='Output file, containing transcript, gene id and the definition (function)')

options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

# Loop over arguments and assign input to infile and output to outfile 
# o == option
# a == argument passed to the o

if myopts == []:
    print("Usage: %s -i input -o output -m mode" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

# -----------------------------------------------------------------------
# function block
# -----------------------------------------------------------------------

def parsing():

    name=[]
    gene_function={}
        
    
    input_file=open(infile, 'r')
    for line in input_file:
        line_split=line.split('\t')
        #print line_split
        gene_id=line_split[2]
        function_cigar=line_split[7].split(" ")
        #print function_cigar
        for item in function_cigar:
            name.append(item)

        function="_".join(name).split(',')[0]          
        #print function
        name=[]

        gene_function[gene_id]=function


    f=open(outfile, 'w')
    for key in gene_function:
        f.write('%s\t' % key)
        f.write('%s\n' % gene_function[key])  
    f.close()
           
parsing()











