#!/usr/bin/python

__author__="BU"

from optparse import OptionParser
import gzip
from os import sys
import getopt

# ===============
## OPTION PARSING
# ===============
parser = OptionParser()
parser.add_option("-i", help="Transcript ids found in given tissue. No stdin")
parser.add_option('-o', help='Output file')
parser.add_option("-t", help="Transcript ids of which presence in the tissue should be investigated")
options, args = parser.parse_args()


# Store input and output file

infile=''
outfile=''
trans=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:t:")

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a
    if o == '-t':
        trans=a

print ("Input file : %s \nOutput file: %s \nTranscripts: %s" % (infile,outfile,trans))

# ========================
# Body of GET_SJ function
# ========================

def tissue_specific():

    tx_tissue=[]
    tx=[]
    tx_stats={}

    tissue_file=open(infile, 'r')
    tx_tissue=[line.split('\n')[0] for line in tissue_file]
    #print tx_tissue  
    
    tx_file=open(trans, 'r')
    tx=[record.split('\n')[0] for record in tx_file]

    for item in tx:
        if item in tx_tissue:
            tx_stats[item]=1
        else:
            tx_stats[item]=0
  
    f=open(outfile, 'w')
    for key in tx_stats:
        f.write('%s\t' % key)
        f.write('%s\n' % tx_stats[key])
    f.close()              

  
tissue_specific()

    
