#!/usr/bin/python

__author__="BUR"


"""This script will help to split overlapping ids as separate entries"""

# Usage python exon.order.py -i input.gtf -o output.tsv

from optparse import OptionParser
import gzip
from os import sys
import getopt
import locale
from functools import cmp_to_key
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
import re


# ===============
## OPTION PARSING
# ===============

parser = OptionParser()
parser.add_option("-i", 
	help="The input format is tab separated file with id in 1st column and the comma separated list of overlapping ids in the 2nd column)")
parser.add_option('-o', help='Tab separtated file with ovelapping ids in separte rows')
options, args = parser.parse_args()

# Store input and output file

infile=''
outfile=''

# Read command line args
myopts, args = getopt.getopt(sys.argv[1:],"i:o:")

if myopts == []:
    print("Usage: %s -i input -o output" % sys.argv[0])

for o, a in myopts:
    if o == '-i':
        infile=a
    if o == '-o':
        outfile=a

print ("Input file : %s \nOutput file: %s" % (infile,outfile))

def slicer():
    "This function slices matrix of genome k-mers and decodes merged regions."
    
    records={}   

    matrix=open(infile, 'r')
    for line in matrix:
        line_split=line.split('\n')[0].split('\t')
        gene_id=line_split[0]
        ref_id=line_split[1]
        biotype=line_split[2]
        status=line_split[3]
 
        if status == "novel":
            ref_id="ENSGXXXXXXXXXXX"
            
        #print "REF", ref_id
        for v in ref_id.split(','):
            #print "V", v      
            coord=v+"\t"+biotype+"\t"+status
        
            if gene_id not in records:
                records[gene_id]=[coord]
            else:   
                records[gene_id].append(coord)


    f=open(outfile, "w")
    for key in records:
        for e in records[key]:
            f.write('%s\t' % key)
            f.write('%s\n' % e)        
    f.close()

slicer()


